option(null: hard);	
/*	
	instrument wrapper functions
	Developer: Algorithmica Research, Magnus Nyström			

	-------------------------------------------------------------------- 
	swap_fltflt2s, 
	--------------------------------------------------------------------
*/
//----------------------------------------------------------------------
//  class swap_fltflt2s
//----------------------------------------------------------------------
class swap_fltflt2s: public swap_gen
option(category: "Instrument/Interest Rate Swap/Float vs Float (2-swap)")
//option(allow_undeclared_mfuncs)
{
public:
    //override string	instr_type_s();
	override instrument 	inst();

	swap_fltflt 			swap_fltflt(error_info option(nullable) error = null<error_info>);
	void					swap_fixflt(out instrument option(nullable)	,
										out instrument option(nullable),
										error_info option(nullable) error = null<error_info> );

	//-----external swap specific-----
	override ql_fixed_income_swap 	swap_instrument(error_info option(nullable) error = null<error_info>) ;
	override instrument_type 		swap_type( error_info option(nullable) error = null<error_info> );
	vector(ql_float_leg) 	float_legs( logical,error_info option(nullable) error = null<error_info>);

	ir_index 				ir_index_sprd_leg( error_info option(nullable) error = null<error_info> ); 
	ir_index 				ir_index_flat_leg( error_info option(nullable) error = null<error_info> ); 
	string 					index_tenor_sprd_leg(error_info option(nullable) error = null<error_info>) ;
	string 					index_tenor_flat_leg(error_info option(nullable) error = null<error_info>) ;
	tenor_code 				index_tenor_code_sprd_leg(error_info option(nullable) error = null<error_info>) ;
	tenor_code				index_tenor_code_flat_leg(error_info option(nullable) error = null<error_info>) ;

	integer 				coupon_freq_fix_leg( error_info option(nullable) error = null<error_info> ); 
	integer 				coupon_freq_sprd_leg( error_info option(nullable) error = null<error_info> ); 
	integer 				coupon_freq_flat_leg( error_info option(nullable) error = null<error_info> ); 
	integer 				reset_freq_sprd_leg( error_info option(nullable) error = null<error_info> ); 
	integer 				reset_freq_flat_leg( error_info option(nullable) error = null<error_info> ); 
	integer 				roll_day_sprd_leg( error_info option(nullable) error = null<error_info> ); 
	integer 				roll_day_flat_leg( error_info option(nullable) error = null<error_info> ); 

	day_count_method		dc_method_fix_leg( error_info option(nullable) error = null<error_info> ); 
	day_count_method		dc_method_sprd_leg( error_info option(nullable) error = null<error_info> ); 
	day_count_method		dc_method_flat_leg( error_info option(nullable) error = null<error_info> ); 

	string					currency_fix_leg( error_info option(nullable) error = null<error_info> ); 
	string					currency_sprd_leg( error_info option(nullable) error = null<error_info> ); 
	string					currency_flat_leg( error_info option(nullable) error = null<error_info> );

	
	bd_convention			pmt_bus_day_fix_leg( error_info option(nullable) error = null<error_info> ); 
	bd_convention			pmt_bus_day_sprd_leg( error_info option(nullable) error = null<error_info> ); 
	bd_convention			pmt_bus_day_flat_leg( error_info option(nullable) error = null<error_info> ); 

	logical					eom_fix_leg( error_info option(nullable) error = null<error_info> ); 
	logical					eom_sprd_leg( error_info option(nullable) error = null<error_info> ); 
	logical					eom_flat_leg( error_info option(nullable) error = null<error_info> ); 

	calendar				calendar_fix_leg( error_info option(nullable) error = null<error_info> ); 
	calendar				calendar_sprd_leg( error_info option(nullable) error = null<error_info> ); 
	calendar				calendar_flat_leg( error_info option(nullable) error = null<error_info> ); 

	override number  		present_value(	disc_func option(nullable),disc_func option(nullable), out number ,
											out number ,number option(nullable) = null<number>, logical option(nullable) trade_date_pv = false,		
											error_info option(nullable) error = null<error_info> );
	
	override number  		present_value(	disc_func option(nullable),disc_func option(nullable),out number ,
											out number,date option(nullable) ,date option(nullable) ,
											logical,logical  ,error_info option(nullable) error = null<error_info> );
	
	override number  		present_value(	out number ,out number pv_flat_leg,
											logical option(nullable) ,error_info option(nullable) error = null<error_info>   );

	logical 				normalize(disc_func option(nullable), error_info option(nullable) error = null<error_info> ) ;
	
	void 		add_notional(number );
	void 		add_notional_sprd_leg(number );
	void 		add_notional_flat_leg(number );
	void 		add_fx_rate_sprd_leg(number );
	void 		add_fx_rate_flat_leg(number );
	void 		add_disc_func(disc_func ); 
	void 		add_disc_func_sprd_leg(disc_func );
	void 		add_disc_func_flat_leg(disc_func );	
	void 		add_surface_sprd_leg(tenor_surface option(nullable));
	void 		add_surface_flat_leg(tenor_surface option(nullable));
	void		add_fixing_sprd_leg(vector(date) ,vector(number) ,logical option(nullable) fixing_as_fwd = false);
	void		add_fixing_flat_leg(vector(date) ,vector(number) ,logical option(nullable) fixing_as_fwd = false);
	void		add_fixing_sprd_leg(number ,logical option(nullable) fixing_as_fwd = false);
	void		add_fixing_flat_leg(number ,logical option(nullable) fixing_as_fwd = false);
	void 		add_data( 	number,disc_func,tenor_surface ,vector(date),vector(number) ,
							tenor_surface ,vector(date),vector(number) ,logical option(nullable) fixing_as_fwd = false,							
							 logical upd_null_crv = false,logical upd_null_fix = false);

	disc_func 	disc_func_sprd_leg(error_info option(nullable) error = null<error_info> ) ;
	disc_func 	disc_func_flat_leg(error_info option(nullable) error = null<error_info> ) ;
	override number		solver(number,swap_solver_code ,logical option(nullable) trade_date_pv = false,
						error_info option(nullable) error = null<error_info> );
	
	/*---set functions-required--*/
	override swap_fltflt2s	set_quote(number option(nullable),error_info option(nullable) error = null<error_info>);
	override swap_fltflt2s	set_quote(string option(nullable),error_info option(nullable) error = null<error_info>);

	swap_fltflt2s(__instrument);	
	override swap_fltflt2s clone() ;
	swap_fltflt2s(swap_fltflt2s);

protected:
	
	override swap_fltflt2s		create(__instrument option(nullable),out instr_error option(nullable) ,
									   error_type type = E_INVALID_ARG); 
					
	override swap_fltflt2s		set_date(date,date option(nullable) s=null<date> ,logical r = true,logical rq = true ,
										 error_info option(nullable) error = null<error_info> );	
	override swap_fltflt2s		set_date(date,logical ,error_info option(nullable) error = null<error_info>);			/*legacy*/
	override swap_fltflt2s		move_date(	date,date option(nullable) s=null<date> ,
											error_info option(nullable) error = null<error_info> );						/*legacy*/

	//void					SWAP_ENTRY_FUNC();
	
	//logical ext_swap_;
	//logical ccy_swap_;
	//logical full_swap_;
};
//------------------------------------------------
// constructor [HIDDEN, cannot be protected]
//------------------------------------------------
swap_fltflt2s.swap_fltflt2s(__instrument i) option(hidden): swap_gen(i){}
//------------------------------------------------
// copy constructor
//------------------------------------------------
swap_fltflt2s.swap_fltflt2s(swap_fltflt2s c) : swap_gen(c)/*,
						  ext_swap_(c.ext_swap_), ccy_swap_(c.ccy_swap_), full_swap_(c.full_swap_)*/ {}
//------------------------------------------------
// copy constructor <FUNCTION>
//------------------------------------------------
swap_fltflt2s swap_fltflt2s(swap_fltflt2s b)			{ return new swap_fltflt2s(b);}
//------------------------------------------------
// clone
//------------------------------------------------
swap_fltflt2s swap_fltflt2s.clone() 	{ return new swap_fltflt2s(this);}

/*-----------------------------------------------------------------------
  member instr_type_s()
  ----------------------------------------------------------------------*/
//string swap_fltflt2s.instr_type_s() 	{ return string(..instr_type.SWAP_FLTFLT2S);}
/*-----------------------------------------------------------------------
  member inst()
  ----------------------------------------------------------------------*/
instrument 	swap_fltflt2s.inst()		{ return this;}
//------------------------------------------------
// create  [PROTECTED]
// create swap_fltflt2s from internal instrument
//------------------------------------------------
swap_fltflt2s swap_fltflt2s.create(	__instrument option(nullable) c,
									out instr_error option(nullable) error ,
									error_type type )
{
	QL_FAIL_COND(null(c), "invalid/unknown (null) instrument",type );

	logical valid = c.is_valid(error);
	if( !valid && INSTR_CREATE_NULL_ERR)
		return null<swap_fltflt2s>; 
	
	..instr_type it = c.instr_type(error);
	QL_FAIL_COND(null(it), "invalid instrument type (unknown)",type );
	QL_FAIL_COND(it != ..instr_type.SWAP_FLTFLT2S, "invalid instrument type",type );//should not happen
	
	return new swap_fltflt2s(c);
}
//-----------------------------------------------
// dynamic cast <FUNCTION>   
//-----------------------------------------------
swap_fltflt2s swap_fltflt2s(instrument i, error_info option(nullable) error = null<error_info>) 	
option (category: 'Instrument/Interest Rate Swap/Float vs Float (2-swap)')
option(com_name: 'swap_fltflt2s_dyncast')
{ 
	try {
		swap_fltflt2s d = dynamic_cast<swap_fltflt2s>(i); 
		if(null(d))
			CORE_INT.add_error_info(error,ERR_T_INIT,"invalid cast (instrument is not a swap_fltflt2s)","swap_fltflt2s" );

		return d;
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "swap_fltflt2s");
		return null<swap_fltflt2s>;
	}
}
/*-----------------------------------------------------------------------
  function: create_swap_fltflt2s
  ----------------------------------------------------------------------*/
swap_fltflt2s create_swap_fltflt2s(	__instrument option(nullable) c,									
									out instr_error option(nullable) error ,
									error_type type = E_INVALID_ARG)
option(com_name: 'INTERNAL_create_swap_fltflt2s')
{
	QL_FAIL_COND(null(c), "invalid/unknown (null) instrument",type );

	logical valid = c.is_valid(error);
	if( !valid && INSTR_CREATE_NULL_ERR)
		return null<swap_fltflt2s>; 
		
	..instr_type it = c.instr_type(error);
	QL_FAIL_COND(null(it), "invalid instrument type (unknown)",type );
	QL_FAIL_COND(it != ..instr_type.SWAP_FLTFLT2S, "invalid instrument type",type );//should not happen
	
	return new swap_fltflt2s(c);
}

swap_fltflt2s create_swap_fltflt2s(	__instrument option(nullable) 		c,
								error_info option(nullable) 		error,
								error_type 							type = E_INIT)
option(com_name: 'INTERNAL_create_swap_fltflt2s_ei')
{
	instr_error ee 	= instr_error();
	swap_fltflt2s b 	= create_swap_fltflt2s(c,ee, E_INIT);
	if(ee.is_error())
		CORE_INT.add_error_info(error,ee.type(),ee.message(), "create_swap_fltflt2s");
	return b;
}
/*-----------------------------------------------------------------------
  swap_fltflt
  ----------------------------------------------------------------------*/
swap_fltflt swap_fltflt2s.swap_fltflt(error_info option(nullable) error )
{
	try {
		error_info ee = error_info(true,true);
		logical ok = this.normalize(null<disc_func>,ee);
		QL_FAIL_COND(!ok, ee.message(), this, true);
		
		ql_fixed_income_swap swap 	= swap_instrument(ee);
		__instrument c 				= __instrument_swap(swap);

		QL_FAIL_COND(null(c), "null instrument", this, true);//should not happen

		instr_error e = new instr_error();
		if(!c.is_valid(e) && INSTR_CREATE_NULL_ERR)
			return create_null_swap_fltflt() ;
			
		return create_swap_fltflt(c, e);			
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "swap_fltflt2s.swap_fltflt");		
		return create_null_swap_fltflt() ;
	}
}
/*-----------------------------------------------------------------------
  swap_fixflt
  ----------------------------------------------------------------------*/

void swap_fltflt2s.swap_fixflt(	out instrument option(nullable)	fix_flt1,//fix cpn=fix_spread vs flt1 flat
								out instrument option(nullable)	fix_flt2,//fix cpn = 0 vs flt2 flatout 
								error_info option(nullable) 	error)
{
	try {
		//this.normalize(	null<disc_func>,error);
		//QL_FAIL_COND(error.is_error(), error.message());
		
		ql_fixed_income_swap sw1,sw2;

		instr_error_type t;
   		string 			s;	
		i().__swap_fltflt2_fixflt(sw1,sw2,t, s);

		error_info ee = new error_info(true,true);
		logical is_e = CORE_INT.add_error_info(ee,t,s, "swap_fltflt2s.swap_fixflt");
		QL_FAIL_COND(is_e, ee.message(), this, true);
		
		__instrument c1 = __instrument_swap(sw1);
		__instrument c2 = __instrument_swap(sw2);

		instr_error e = instr_error();
		if(c1.is_valid(e))			
			fix_flt1 = create_swap_fixflt(c1, e);	
		else
			fix_flt1 = create_null_swap_fixflt();

		QL_FAIL_COND(null(fix_flt1), e.message(), this, true);
		
		if(c2.is_valid(e))			
			fix_flt2 = create_swap_fixflt(c2, e);	
		else
			fix_flt2 = create_null_swap_fixflt();
		
		QL_FAIL_COND(null(fix_flt2), e.message(), this, true);
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "swap_fltflt2s.swap_fixflt");		
		return  ;
	}
}
/*-----------------------------------------------------------------------
  set_date <protected>
	if trade date is the same --> the settle date will be preserved (if not input)	
	NOTE: 	if coupon is not null in instr_def it is kept unchanged --> deposit will be non-par 
			when a deposit is defined in db the coupon is always null
  ----------------------------------------------------------------------*/
swap_fltflt2s swap_fltflt2s.set_date(	date  				trade_date, 
										date  option(nullable)	settle_date,
										logical 			re_init_static, 
										logical 			re_init_quote, 
										error_info option(nullable) error)
{	
	instrument cc = instrument._set_date(trade_date,null<date>,true,re_init_quote,error);
	return null(cc) ? null<swap_fltflt2s>: dynamic_cast<swap_fltflt2s>(cc);
	
}

/*-----------------------------------------------------------------------
  set_date <protected/legacy>
	quote is NOT kept even if trade_date is unchanged
  ----------------------------------------------------------------------*/
swap_fltflt2s swap_fltflt2s.set_date(	date  				trade_date, 
										logical 			re_init_static, 
										error_info option(nullable) error) 

{	
	instrument cc = instrument._set_date(trade_date,true,error);
	return null(cc) ? null<swap_fltflt2s>: dynamic_cast<swap_fltflt2s>(cc);	
}

/*-----------------------------------------------------------------------
   move_date  <protected/legacy>
	changes the trade date of the instrument without retrieving the 
 	corresponding quote from the database or the real-time feed.
	if trade date is the same --> the settle date will be preserved	
  ----------------------------------------------------------------------*/
swap_fltflt2s swap_fltflt2s.move_date(	date  				trade_date, 
										date option(nullable) settle_date,
										error_info option(nullable) error) 
{	
	instrument cc = instrument._move_date(trade_date,null<date>,error);
	return null(cc) ? null<swap_fltflt2s>: dynamic_cast<swap_fltflt2s>(cc);
}

/*-----------------------------------------------------------------------
  swap_fltflt2s: set_quote 
  ----------------------------------------------------------------------*/
swap_fltflt2s swap_fltflt2s.set_quote(	number 	option(nullable) quote,									
										error_info option(nullable) error)
{	
	instrument cc = instrument._set_quote(quote,null<date>, null<date>, false,error);
	return null(cc) ? null<swap_fltflt2s>: dynamic_cast<swap_fltflt2s>(cc);
}

/*-----------------------------------------------------------------------
  swap_fltflt2s: set_quote
  ----------------------------------------------------------------------*/
swap_fltflt2s swap_fltflt2s.set_quote(	string 	option(nullable) quote_side,								
										error_info option(nullable) error)
{	
	instrument cc = instrument._set_quote(quote_side,null<date>, null<date>, false,error);
	return null(cc) ? null<swap_fltflt2s>: dynamic_cast<swap_fltflt2s>(cc);
}

/*-----------------------------------------------------------------------
  swap_fltflt2s: coupon_freq_fix_leg
  ----------------------------------------------------------------------*/
integer swap_fltflt2s.coupon_freq_fix_leg(error_info option(nullable) error)
{	
	return instrument.coupon_freq(error);
} 

/*-----------------------------------------------------------------------
  swap_fltflt2s: coupon_freq_sprd_leg
  ----------------------------------------------------------------------*/
integer swap_fltflt2s.coupon_freq_sprd_leg(error_info option(nullable) error)
{	
	return this.instr_def().swap_coupon_freq_leg1(error);
} 

/*-----------------------------------------------------------------------
  swap_fltflt2s: coupon_freq_flat_leg
  ----------------------------------------------------------------------*/
integer 	swap_fltflt2s.coupon_freq_flat_leg(error_info option(nullable) error)
{	
	return this.instr_def().swap_coupon_freq_leg2(error);
} 
/*-----------------------------------------------------------------------
  swap_fltflt2s: reset_freq_sprd_leg
  ----------------------------------------------------------------------*/
integer swap_fltflt2s.reset_freq_sprd_leg(error_info option(nullable) error)
{	
	return this.instr_def().swap_reset_freq_leg1(error);
} 

/*-----------------------------------------------------------------------
  swap_fltflt2s: reset_freq_flat_leg
  ----------------------------------------------------------------------*/
integer 	swap_fltflt2s.reset_freq_flat_leg(error_info option(nullable) error)
{	
	return this.instr_def().swap_reset_freq_leg2(error);
} 
/*-----------------------------------------------------------------------
  swap_fltflt2s: roll_day_sprd_leg
  ----------------------------------------------------------------------*/
integer swap_fltflt2s.roll_day_sprd_leg(error_info option(nullable) error)
{	
	return this.instr_def().swap_roll_day_leg1(error);
} 

/*-----------------------------------------------------------------------
  swap_fltflt2s: roll_day_flat_leg
  ----------------------------------------------------------------------*/
integer 	swap_fltflt2s.roll_day_flat_leg(error_info option(nullable) error)
{	
	return this.instr_def().swap_roll_day_leg2(error);
} 

/*-----------------------------------------------------------------------
  swap_fltflt2s: dc_method_fix_leg
  ----------------------------------------------------------------------*/
day_count_method swap_fltflt2s.dc_method_fix_leg(error_info option(nullable) error)
{	
	return instrument.dc_method(error);
} 

/*-----------------------------------------------------------------------
  swap_fltflt2s: dc_method_sprd_leg
  ----------------------------------------------------------------------*/
day_count_method swap_fltflt2s.dc_method_sprd_leg(error_info option(nullable) error)
{	
	return this.instr_def().swap_dc_method_leg1(error);
} 

/*-----------------------------------------------------------------------
  swap_fltflt2s: dc_method_flat_leg
  ----------------------------------------------------------------------*/
day_count_method 	swap_fltflt2s.dc_method_flat_leg(error_info option(nullable) error)
{	
	return this.instr_def().swap_dc_method_leg2(error);
} 

/*-----------------------------------------------------------------------
  swap_fltflt2s: currency_fix_leg
  ----------------------------------------------------------------------*/
string swap_fltflt2s.currency_fix_leg(error_info option(nullable) error)
{	
	return instrument.currency(error);
} 

/*-----------------------------------------------------------------------
  swap_fltflt2s: currency_sprd_leg
  ----------------------------------------------------------------------*/
string swap_fltflt2s.currency_sprd_leg(error_info option(nullable) error)
{	
	return this.instr_def().swap_currency_leg1(error);
} 

/*-----------------------------------------------------------------------
  swap_fltflt2s: currency_flat_leg
  ----------------------------------------------------------------------*/
string	swap_fltflt2s.currency_flat_leg(error_info option(nullable) error)
{	
	return this.instr_def().swap_currency_leg2(error);
}

/*-----------------------------------------------------------------------
  swap_fltflt2s: pmt_bus_day_fix_leg
  ----------------------------------------------------------------------*/
bd_convention swap_fltflt2s.pmt_bus_day_fix_leg(error_info option(nullable) error)
{	
	return instrument.pmt_bus_day(error);
} 

/*-----------------------------------------------------------------------
  swap_fltflt2s: pmt_bus_day_sprd_leg
  ----------------------------------------------------------------------*/
bd_convention swap_fltflt2s.pmt_bus_day_sprd_leg(error_info option(nullable) error)
{	
	return this.instr_def().swap_pmt_bus_day_leg1(error);
} 

/*-----------------------------------------------------------------------
  swap_fltflt2s: pmt_bus_day_flat_leg
  ----------------------------------------------------------------------*/
bd_convention 	swap_fltflt2s.pmt_bus_day_flat_leg(error_info option(nullable) error)
{	
	return this.instr_def().swap_pmt_bus_day_leg2(error);
} 

/*-----------------------------------------------------------------------
  swap_fltflt2s: eom_fix_leg
  ----------------------------------------------------------------------*/
logical swap_fltflt2s.eom_fix_leg(error_info option(nullable) error)
{	
	return instrument.eom(error);
} 

/*-----------------------------------------------------------------------
  swap_fltflt2s: eom_sprd_leg
  ----------------------------------------------------------------------*/
logical swap_fltflt2s.eom_sprd_leg(error_info option(nullable) error)
{	
	return this.instr_def().swap_eom_leg1(error);
} 

/*-----------------------------------------------------------------------
  swap_fltflt2s: eom_flat_leg
  ----------------------------------------------------------------------*/
logical  	swap_fltflt2s.eom_flat_leg(error_info option(nullable) error)
{	
	return this.instr_def().swap_eom_leg2(error);
} 

/*-----------------------------------------------------------------------
  swap_fltflt2s: calendar_fix_leg
  ----------------------------------------------------------------------*/
calendar swap_fltflt2s.calendar_fix_leg(error_info option(nullable) error)
{	
	return instrument.calendar(0,error);
} 

/*-----------------------------------------------------------------------
  swap_fltflt2s: calendar_sprd_leg
  ----------------------------------------------------------------------*/
calendar swap_fltflt2s.calendar_sprd_leg(error_info option(nullable) error)
{	
	return this.instr_def().swap_calendar_leg1(error);
} 

/*-----------------------------------------------------------------------
  swap_fltflt2s: calendar_flat_leg
  ----------------------------------------------------------------------*/
calendar  	swap_fltflt2s.calendar_flat_leg(error_info option(nullable) error)
{	
	return this.instr_def().swap_calendar_leg2(error);
} 

/*-----------------------------------------------------------------------
  swap_fltflt2s: add_funcs
  ----------------------------------------------------------------------*/
void swap_fltflt2s.add_notional(number notional)				{ swap_gen.swap_add_notional(notional);}
void swap_fltflt2s.add_notional_sprd_leg(number notional) 		{ swap_gen.swap_add_notional_leg1(notional);}
void swap_fltflt2s.add_notional_flat_leg(number notional)		{ swap_gen.swap_add_notional_leg2(notional);	}
void swap_fltflt2s.add_fx_rate_sprd_leg(number fx_rate)			{ swap_gen.swap_add_fx_rate_leg1(fx_rate);}
void swap_fltflt2s.add_fx_rate_flat_leg(number fx_rate)			{ swap_gen.swap_add_fx_rate_leg2(fx_rate);}
void swap_fltflt2s.add_disc_func(disc_func disc_func)			{ swap_gen.swap_add_disc_func(disc_func); }
void swap_fltflt2s.add_disc_func_sprd_leg(disc_func disc_func)	{ swap_gen.swap_add_disc_func_leg1(disc_func); }
void swap_fltflt2s.add_disc_func_flat_leg(disc_func  disc_func) { swap_gen.swap_add_disc_func_leg2(disc_func); }

void swap_fltflt2s.add_surface_sprd_leg(tenor_surface option(nullable) tenor_surface) { swap_gen.swap_add_surface_leg1(tenor_surface);}
void swap_fltflt2s.add_fixing_sprd_leg(	vector(date) fixing_dates,
										vector(number) fixings,
										logical option(nullable) fixing_as_fwd )
{			
	swap_gen.swap_add_fixing_leg1(fixing_dates,fixings,fixing_as_fwd);						
}
void swap_fltflt2s.add_surface_flat_leg(tenor_surface option(nullable) tenor_surface)	{ swap_gen.swap_add_surface_leg2(tenor_surface);}
void swap_fltflt2s.add_fixing_flat_leg(	vector(date) fixing_dates,
										vector(number) fixings,
										logical option(nullable) fixing_as_fwd )
{			
	swap_gen.swap_add_fixing_leg2(fixing_dates,fixings,fixing_as_fwd);						
}
void swap_fltflt2s.add_fixing_sprd_leg(number fixing_proxy,
									logical option(nullable) fixing_as_fwd ) 
{			
	swap_gen.swap_add_fixing_leg1(fixing_proxy, fixing_as_fwd);						
}
void swap_fltflt2s.add_fixing_flat_leg(number fixing_proxy,
									logical option(nullable) fixing_as_fwd ) 
{			
	swap_gen.swap_add_fixing_leg2(fixing_proxy, fixing_as_fwd);						
}

/*void swap_fltflt2s.add_data(number 			notional,
							disc_func 		disc_func,
							tenor_surface 	tenor_surface_sprd_leg,	
							vector(date) 	fixing_dates_sprd_leg,
							vector(number) 	fixings_sprd_leg,
							tenor_surface 	tenor_surface_flat_leg,
							vector(date) 	fixing_dates_flat_leg,
							vector(number) 	fixings_flat_leg,
							logical option(nullable) fixing_as_fwd )
{			
	swap_gen.swap_add_fltflt_data(notional,disc_func, tenor_surface_sprd_leg,fixing_dates_sprd_leg,fixings_sprd_leg,
						tenor_surface_flat_leg,fixing_dates_flat_leg,fixings_flat_leg, fixing_as_fwd);						
}*/

/*-----------------------------------------------------------------------
  swap_add_fltflt_data
  ----------------------------------------------------------------------*/
void swap_fltflt2s.add_data( 	number 			notional,
							disc_func 		disc_func,
							tenor_surface 	tenor_surface_sprd_leg,	
							vector(date) 	fixing_dates_sprd_leg,
							vector(number) 	fixings_sprd_leg,
							tenor_surface 	tenor_surface_flat_leg,
							vector(date) 	fixing_dates_flat_leg,
							vector(number) 	fixings_flat_leg,
							logical option(nullable) fixing_as_fwd,
							logical upd_null_crv ,
							logical upd_null_fix )  
{			
	i().__swap_add_fltflt_data(notional,disc_func, tenor_surface_sprd_leg,fixing_dates_sprd_leg,fixings_sprd_leg,
						tenor_surface_flat_leg,fixing_dates_flat_leg,fixings_flat_leg, fixing_as_fwd,upd_null_crv,upd_null_fix);
	return ;						
}
/*-----------------------------------------------------------------------
  swap_fltflt2s: disc_func_sprd_leg / disc_func_flat_leg
  ----------------------------------------------------------------------*/
disc_func swap_fltflt2s.disc_func_sprd_leg(error_info option(nullable) error) 		{ return swap_gen.swap_disc_func_leg1(error);}
disc_func swap_fltflt2s.disc_func_flat_leg(error_info option(nullable) error) 		{ return swap_gen.swap_disc_func_leg2(error);}
/*-----------------------------------------------------------------------
  swap_type
  ----------------------------------------------------------------------*/
instrument_type swap_fltflt2s.swap_type(error_info option(nullable) error) 
{	
	return swap_gen.swap_type(error);
}

/*-----------------------------------------------------------------------
  solver
  ----------------------------------------------------------------------*/
number swap_fltflt2s.solver(	number 				pv,
								swap_solver_code 	solver_code,
								logical option(nullable) trade_date_pv,
								error_info option(nullable) error)
{	
	return swap_gen.solver(pv,solver_code,trade_date_pv,error);
}

/*-----------------------------------------------------------------------
  swap_instrument
  ----------------------------------------------------------------------*/
ql_fixed_income_swap swap_fltflt2s.swap_instrument(error_info option(nullable) error)
{
	return swap_gen.swap_instrument(error);

}

/*-----------------------------------------------------------------------
  normalize
  ----------------------------------------------------------------------*/
logical swap_fltflt2s.normalize(disc_func option(nullable) disc_func,
								error_info option(nullable) error)
{	
	try{	
		instr_error_type t;
   		string 			s;	
		i().__swap_normalize_fltflt_2swap(disc_func,t, s);
		logical e = CORE_INT.add_error_info(error,t,s, "swap_fltflt2s.normalize");
		return !e;		
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "swap_fltflt2s.normalize");		
		return false;
	}
}

/*-----------------------------------------------------------------------
  swap_fltflt: ir_index_sprd_leg
  ----------------------------------------------------------------------*/
ir_index swap_fltflt2s.ir_index_sprd_leg(error_info option(nullable) error)
{	
	return swap_gen.swap_ir_index_leg1(error);
}


/*-----------------------------------------------------------------------
  index_tenor_sprd_leg
  ----------------------------------------------------------------------*/
string swap_fltflt2s.index_tenor_sprd_leg(error_info option(nullable) error) 
{	
	return swap_gen.swap_index_tenor_leg1(error);
}

/*-----------------------------------------------------------------------
  index_tenor_flat_leg
  ----------------------------------------------------------------------*/
string swap_fltflt2s.index_tenor_flat_leg(error_info option(nullable) error) 
{	
	return swap_gen.swap_index_tenor_leg2(error);
}


/*-----------------------------------------------------------------------
  swap_fltflt2s : ir_index_flat_leg
  ----------------------------------------------------------------------*/
ir_index swap_fltflt2s.ir_index_flat_leg(error_info option(nullable) error)
{	
	return swap_gen.swap_ir_index_leg2(error);
}


/*-----------------------------------------------------------------------
  index_tenor_code_sprd_leg
  ----------------------------------------------------------------------*/
tenor_code swap_fltflt2s.index_tenor_code_sprd_leg(error_info option(nullable) error) 
{	
	return swap_gen.swap_index_tenor_code_leg1(error);
}

/*-----------------------------------------------------------------------
  index_tenor_code_flat_leg
  ----------------------------------------------------------------------*/
tenor_code swap_fltflt2s.index_tenor_code_flat_leg(error_info option(nullable) error) 
{	
	return swap_gen.swap_index_tenor_code_leg2(error);
}


/*-----------------------------------------------------------------------
  float_legs  (normalize(...) will be executed on the dll side)
  ----------------------------------------------------------------------*/
vector(ql_float_leg) swap_fltflt2s.float_legs(logical clone,error_info option(nullable) error)
{	
	return swap_gen.swap_float_leg(clone,error);
}
	
/*-----------------------------------------------------------------------
  present_value
  ----------------------------------------------------------------------*/
number swap_fltflt2s.present_value(	disc_func option(nullable)	disc_func_sprd_leg,
									disc_func option(nullable) 	disc_func_flat_leg,
									out number pv_sprd_leg,
									out number pv_flat_leg,
									number option(nullable) 	notional,
									logical option(nullable) 	trade_date_pv,																								
									error_info option(nullable) error)
{	
	return swap_gen.present_value(disc_func_sprd_leg,disc_func_flat_leg,pv_sprd_leg,pv_flat_leg,notional,trade_date_pv,error);
}


number swap_fltflt2s.present_value(	disc_func option(nullable)	disc_func_sprd_leg,
									disc_func option(nullable) 	disc_func_flat_leg,
									out number pv_sprd_leg,
									out number pv_flat_leg,
									date option(nullable) pv_date,
									date option(nullable) settle_date,
									logical  	incl_issue_cf,
									logical  	incl_mat_cf,	
									error_info option(nullable) error)
{	
	return swap_gen.present_value(disc_func_sprd_leg,disc_func_flat_leg,pv_sprd_leg,pv_flat_leg,pv_date, settle_date ,incl_issue_cf,incl_mat_cf,error );
}

number swap_fltflt2s.present_value(out number pv_sprd_leg,
										out number pv_flat_leg,
										logical option(nullable) 	trade_date_pv,																								
										error_info option(nullable) error)
{	
	return swap_gen.present_value(pv_sprd_leg,pv_flat_leg,trade_date_pv ,error );
}

