/*	
	quote_link class
	Developer: Algorithmica Research, Magnus Nyström			
*/

option(null: hard);	

//enum quote_link_qs {BID, ASK, MID};

//-------------------------------------------------------
// class quote_source_h - DUMMY
//-------------------------------------------------------
class quote_source_h
{
public:
	quote_source_h(string );	
			
	string source();

protected:

	string source_;
		
};

quote_source_h.quote_source_h(string source)
					:source_(source)
{
}

string quote_source_h.source() { return source_; }

quote_source_h quote_source_h(string source) 
option(com_name: 'quote_source_h')
{
	return new quote_source_h(source);
}

//-------------------------------------------------------
// class quote_source_rt
//-------------------------------------------------------
class quote_source_rt
{
public:
	quote_source_rt(string ,string ,integer ,logical);	
			
	string source();
	string feed();
	integer timeout(); 
	logical allow_stale();
	map_istr_str fid_map();

protected:

	string source_;
	string feed_;
	integer timeout_; 
	logical allow_stale_;
	map_istr_str fid_map_;
				
};

quote_source_rt.quote_source_rt(string source,string feed,integer timeout,logical allow_stale)
					:source_(source),feed_(feed),timeout_(timeout), allow_stale_(allow_stale)
{
	fid_map_ = map_istr_str();
	fid_map_.add('bid', '22');
   	fid_map_.add('ask', '25');
    fid_map_.add('last', '6');
	fid_map_.add('TRDPRC_1', '6');
	fid_map_.add('PRIMACT_1', '393');
	fid_map_.add('PRIM ACT 1', '393');

}

string quote_source_rt.source() { return source_; }
string quote_source_rt.feed() { return feed_; }
integer quote_source_rt.timeout() { return timeout_; }
logical quote_source_rt.allow_stale() { return allow_stale_; }
map_istr_str quote_source_rt.fid_map() { return fid_map_; }

quote_source_rt quote_source_rt(string source,string feed,integer timeout,logical allow_stale) 
option(com_name: 'quote_source_rt')
{
	return new quote_source_rt(source,feed,timeout,allow_stale);
}


//-------------------------------------------------------
// class quote_link
//-------------------------------------------------------
class quote_link
{
public:
	quote_link(quote_source_rt,date,string, string option(nullable) ,string option(nullable));	
	//quote_link(quote_source_h, quote_source_rt,date,string, string option(nullable) ,string option(nullable), logical option(nullable));	
		
	string rt_id();
	string rt_field_id();//22
	string rt_field_acro();//"bid"
	string rt_source();
	string rt_feed();
	integer rt_timeout(); 
	logical rt_allow_stale();
	number quote();
 	string h_source();

protected:

	string 			rt_id_;
	string 			rt_field_id_;
	string 			rt_field_acro_;
	quote_source_rt rt_source_;
	logical			is_rt_;
	quote_source_h 	h_source_;
	logical			is_h_;				
};

quote_link.quote_link(	quote_source_rt 		rt_source,
						date 					quote_d,
						string 					rt_id,
						string option(nullable) rt_field_acro,
						string option(nullable) rt_field_id)
						:rt_id_(rt_id), rt_field_id_(rt_field_id), rt_field_acro_(rt_field_acro), rt_source_(rt_source), is_rt_(false), 
						 h_source_(null<quote_source_h>), is_h_(false)
{	
	if(null(rt_field_id_)) {
		QL_FAIL_COND(null(rt_field_acro_),"missing field id and field acronym");
		rt_field_id_ = rt_source_.fid_map().find(rt_field_acro_);
	}
	QL_FAIL_COND(null(rt_field_id_),"invalid field id and/or field acronym");
	
	is_rt_ = quote_d == today();
}

string quote_link.rt_id() 			{ return rt_id_; }
string quote_link.rt_field_id() 	{ return rt_field_id_; }
string quote_link.rt_field_acro() 	{ return rt_field_acro_; }
string quote_link.rt_source() 		{ return rt_source_.source(); }
string quote_link.h_source() 		{ return rt_source_.source(); }
string quote_link.rt_feed() 		{ return rt_source_.feed(); }
integer quote_link.rt_timeout() 	{ return rt_source_.timeout(); }
logical quote_link.rt_allow_stale() { return rt_source_.allow_stale(); }

number quote_link.quote()
{ 
	if(is_rt_)
		return rt.get_num(	rt_id_, rt_field_id_, rt_source(), rt_feed(),rt_timeout(),rt_allow_stale()) ;
	else if(is_h_)
		return null<number>;//for now
	else
		return null<number>;
}


quote_link quote_link_rt(quote_source_rt 		rt_source,
						date					quote_d,
						string 					rt_id,
						string option(nullable) rt_field_acro,
						string option(nullable) rt_field_id= null<string>,						
						error_info option(nullable) error = null<error_info>) 
{
	try {
		return new quote_link(rt_source,quote_d,rt_id,rt_field_acro,rt_field_id);
	}
	catch {	
		CORE_INT.catch_error_info(error,err.type(),err.message(), "quote_link_rt");
		return null<quote_link>;
	}
}


