/*	
	instrument wrapper functions
	Developer: Algorithmica Research_; Magnus Nyström			




*/
class enum cut_off_type {
	CPN_DATE_HIST 		option(str: "CpndateBack"),
	PMT_DATE_IR_HIST 	option(str: "InterestPmtDateBack"),
	PMT_DATE_PRIN_HIST 	option(str: "PrincipalPmtDateBack"),
	CPN_DATE_FWD 		option(str: "CpndateFwd"),
	PMT_DATE_IR_FWD 	option(str: "InterestPmtDateFwd"),
	PMT_DATE_PRIN_FWD 	option(str: "PrincipalPmtDateFwd"),
	ALL 				option(str: "All") 
	};
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//  class swap_leg_data
//----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
class swap_leg_data
{
public:

	void 			pmtdates_cf(out vector(date) , out vector(number),out vector(number) ,out vector(number) ,out vector(number),
								out vector(number) ,out vector(number) ,out vector(number),
								date option(nullable) =null<date> );
	void 			pmtdates_ircf(	logical ,out vector(date) ,out vector(number),out vector(number),out vector(number),date option(nullable) =null<date> );
	void 			pmtdates_princf(logical ,out vector(date) ,out vector(number),out vector(number),date option(nullable) =null<date> );
	void			accrual(out vector(date) , out vector(date) , out vector(number), date option(nullable) =null<date>);
	
	vector(number) 	rate(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type>  );
	vector(number) 	cpn_rate(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	vector(number) 	cf(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	vector(number) 	pv_cf(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	vector(number) 	fx_rate(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	vector(number) 	ir_cf(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	vector(number) 	pv_ir_cf(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	vector(number) 	fee(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	vector(number) 	pv_fee(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	vector(number) 	df_value(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	vector(number) 	notional(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	vector(number)	notional_avg(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	vector(number) 	cpn_notional(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	vector(number) 	notional_incr_sink(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	vector(number) 	not_multi_fact(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	vector(date) 	cpn_date(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	vector(date) 	cpn_date_adj(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	vector(date) 	pmt_date_ir(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );	
	vector(date)  	accr_start(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	vector(date) 	accr_end(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	vector(number) 	accr_per(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	vector(date) 	ref_start(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	vector(date) 	ref_end(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type> );
	
	//prin
	vector(date) 	event_date_prin(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type>  );
	vector(date) 	event_date_adj_prin(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type>  );
	vector(date) 	pmt_date_prin(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type>  );
	vector(number) 	cf_prin(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type>  );
	vector(number) 	pv_cf_prin(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type>  );
	vector(number) 	fx_rate_prin(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type>  );
	vector(number) 	acc_cf_prin(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type>  );
	vector(date) 	reset_prin(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type>  );
	
protected:
	
	swap_leg_data(ql_swap_leg,instrument_type);

	logical 				prin_add_date_exist();
	void 					index_calc_fwd(	vector(date),date ,out integer ,out integer ,out integer );
	void					cut_off_defaults(out date cut_off, out cut_off_type cut_t );
	void 					cut_off_calc(logical,date, cut_off_type, out integer, out integer, out integer );
	virtual vector(number) 	out_number(logical,date option(nullable) , cut_off_type option(nullable) , vector(number) );
	virtual vector(date) 	out_date(logical,date option(nullable) , cut_off_type option(nullable) , vector(date) );
	virtual vector(logical) out_logical(logical,date option(nullable) , cut_off_type option(nullable) , vector(logical) );
	
	vector(date)			consolidate_pmt_date_all(out vector(integer),out vector(integer));
	void 					consolidate_tot_cf_all(	out vector(date)  , out vector(number) ,out vector(number) ,
													out vector(number) ,out vector(number) , out vector(number),
													out vector(number),out vector(number) ,out vector(integer),out vector(integer));
		
	ql_swap_leg 	leg_;
	
public:	
//protected:	
	instrument_type leg_type_;
	vector(number) 	rate_;
	vector(number) 	cpn_rate_;
	vector(number) 	cf_;
	vector(number) 	pv_cf_;
	vector(number) 	fx_rate_;
	vector(number) 	ir_cf_;
	vector(number) 	pv_ir_cf_;
	vector(number) 	fee_;
	vector(number) 	pv_fee_;
	vector(number) 	df_value_;
	vector(number) 	notional_;
	vector(number)	notional_avg_;
	vector(number) 	cpn_notional_;
	vector(number) 	notional_incr_sink_;
	vector(number) 	not_multi_fact_;
	vector(date) 	cpn_date_;
	vector(date) 	cpn_date_adj_;
	vector(date) 	pmt_date_ir_;	
	vector(date)  	accr_start_;
	vector(date) 	accr_end_;
	vector(number) 	accr_per_;
	vector(date) 	ref_start_;
	vector(date) 	ref_end_;
		
	//prin
	vector(date) 	event_date_prin_;
	vector(date) 	event_date_adj_prin_;
	vector(date) 	pmt_date_prin_;
	vector(number) 	cf_prin_;
	vector(number) 	pv_cf_prin_;
	vector(number) 	fx_rate_prin_;
	vector(number) 	acc_cf_prin_;
	vector(date) 	reset_prin_;								 
};
/*-----------------------------------------------------------------------
  swap_leg_data constructor  prot
  ----------------------------------------------------------------------*/
swap_leg_data.swap_leg_data(ql_swap_leg leg,instrument_type leg_type) : leg_(leg), leg_type_(leg_type)
{
	QL_FAIL_COND(leg_type_ != leg.type(),"wrong type of swap leg");
	
	leg_.event_data_dump( cpn_date_,cpn_date_adj_,rate_, cpn_rate_,
						 cf_, pv_cf_,
						 fx_rate_,
						 ir_cf_, pv_ir_cf_,
						 fee_, pv_fee_,
						 df_value_,
						 notional_, notional_avg_, cpn_notional_, notional_incr_sink_, not_multi_fact_,
						 pmt_date_ir_,						
						 accr_start_, accr_end_, accr_per_,
						 ref_start_, ref_end_,
						 event_date_prin_,event_date_adj_prin_,pmt_date_prin_, cf_prin_, pv_cf_prin_, fx_rate_prin_,
						 acc_cf_prin_, reset_prin_);
}
/*-----------------------------------------------------------------------
  prin_add_date_exist
  ----------------------------------------------------------------------*/
logical swap_leg_data.prin_add_date_exist()
{
	vector(integer) f 	= ..v_find(pmt_date_ir_, pmt_date_prin_);	
	integer add 		= v_size(pmt_date_prin_) - v_size(f);	
	return add > 0;
}
/*-----------------------------------------------------------------------
  consolidate_pmt_date_all
  ----------------------------------------------------------------------*/
vector(date) swap_leg_data.consolidate_pmt_date_all(out vector(integer) pir_i,
												out vector(integer) pp_i)
{
	return CORE_INT.consolidate_date(pmt_date_ir_, pmt_date_prin_, pir_i, pp_i);				
}
/*-----------------------------------------------------------------------
  consolidate_tot_cf_all
  ----------------------------------------------------------------------*/
void swap_leg_data.consolidate_tot_cf_all(	out vector(date) 	pmt_date,
											out vector(number) 	cf_ir,
											out vector(number) 	cf_prin,
											out vector(number) 	cf_tot,
											out vector(number) 	pv_cf_ir,
											out vector(number) 	pv_cf_prin,
											out vector(number) 	pv_cf_tot,
											out vector(number) 	cpn_rate,
											out vector(integer) pir_i,
											out vector(integer) pp_i)
{
	pmt_date = CORE_INT.consolidate_date(pmt_date_ir_, pmt_date_prin_, pir_i, pp_i);

	integer s = v_size(pmt_date);
	resize(cf_ir,s);
	resize(cf_prin,s);
	resize(cf_tot,s);
	resize(pv_cf_ir,s);
	resize(pv_cf_prin,s);
	resize(pv_cf_tot,s);
	resize(cpn_rate,s);
	cf_ir = 0;
	cf_prin = 0;
	cf_tot = 0;
	pv_cf_ir = 0;
	pv_cf_prin = 0;
	pv_cf_tot = 0;
	cpn_rate = null<number>;
	
	for(integer i;i<s;i++) {
		if(pir_i[i] != -1){
			cf_ir[i] = ir_cf_[pir_i[i]];
			cf_tot[i] += cf_ir[i];
			pv_cf_ir[i] = pv_ir_cf_[pir_i[i]];
			pv_cf_tot[i] += pv_cf_ir[i];
			cpn_rate[i] = cpn_rate_[pir_i[i]];
		}
		if(pp_i[i] != -1){
			cf_prin[i] = cf_prin_[pp_i[i]];
			cf_tot[i] += cf_prin[i];
			pv_cf_prin[i] = pv_cf_prin_[pp_i[i]];
			pv_cf_tot[i] += pv_cf_prin[i];
		}
	}
	
}
/*-----------------------------------------------------------------------
  index_calc
  ----------------------------------------------------------------------*/
void swap_leg_data.index_calc_fwd(	vector(date) date_v,
									date cut_off,
									out integer start_i,	
									out integer end_i,
									out integer n)
{
	start_i = 0;	
	end_i = v_size(date_v)-1;

	while(cut_off >= date_v[start_i])
		start_i++;

	n = end_i-start_i+1;
}
/*-----------------------------------------------------------------------
  accrual
  ----------------------------------------------------------------------*/
void swap_leg_data.accrual(	out vector(date) accr_start,
							out vector(date) accr_end,
							out vector(number) accr_per,
							date option(nullable) cut_off)
{
	
	 accr_start = this.accr_start(cut_off,cut_off_type.CPN_DATE_FWD);
	 accr_end 	= this.accr_end(cut_off,cut_off_type.CPN_DATE_FWD);
	 accr_per 	= this.accr_per(cut_off,cut_off_type.CPN_DATE_FWD);
	 return;
	
}
/*-----------------------------------------------------------------------
  pmtdates_cf
  ----------------------------------------------------------------------*/
void swap_leg_data.pmtdates_cf(	out vector(date) 	pmt_date,
								out vector(number) 	cpn_r,
								out vector(number) 	cf_ir,
								out vector(number) 	cf_prin,
								out vector(number) 	cf_tot,
								out vector(number) 	pv_cf_ir,
								out vector(number) 	pv_cf_prin,
								out vector(number) 	pv_cf_tot,
								date option(nullable) cut_off )
{
	vector(integer) pir_i, pp_i;
	if(null(cut_off)){		
		consolidate_tot_cf_all(pmt_date, cf_ir,cf_prin,cf_tot,pv_cf_ir, pv_cf_prin, pv_cf_tot,cpn_r,pir_i, pp_i);
		return;
	}
		
	vector(date) pmt_date_all;
	vector(number) cf_ir_all,cf_prin_all,cf_tot_all,cpn_rate_all;
	vector(number) 	pv_cf_ir_all, pv_cf_prin_all, pv_cf_tot_all;
	consolidate_tot_cf_all(pmt_date_all, cf_ir_all,cf_prin_all,cf_tot_all,
						   pv_cf_ir_all, pv_cf_prin_all, pv_cf_tot_all,
						   cpn_rate_all,pir_i, pp_i);
			
	integer start_i,end_i,n ;
	index_calc_fwd(	pmt_date_all,cut_off, start_i, end_i, n);
	QL_REQUIRE(n>0,"invalid vector size");

	resize(pmt_date,n);
	resize(cf_ir,n);
	resize(cf_prin,n);
	resize(cf_tot,n);
	resize(pv_cf_ir,n);
	resize(pv_cf_prin,n);
	resize(pv_cf_tot,n);
	resize(cpn_r,n);
	
	cf_ir = 0;
	cf_prin = 0;
	cf_tot = 0;
	pv_cf_ir = 0;
	pv_cf_prin = 0;
	pv_cf_tot = 0;
	cpn_r = null<number>;
	
	for(integer j=start_i; j <= end_i; j++) {
		pmt_date[j-start_i] = pmt_date_all[j];
		cf_ir[j-start_i] 	= cf_ir_all[j];
		cf_prin[j-start_i] 	= cf_prin_all[j];
		cf_tot[j-start_i] 	= cf_tot_all[j];
		pv_cf_ir[j-start_i] 	= pv_cf_ir_all[j];
		pv_cf_prin[j-start_i] 	= pv_cf_prin_all[j];
		pv_cf_tot[j-start_i] 	= pv_cf_tot_all[j];
		cpn_r[j-start_i] 	= cpn_rate_all[j];
	}
		
	return;
}
/*-----------------------------------------------------------------------
  pmtdates_ircf
  ----------------------------------------------------------------------*/
void swap_leg_data.pmtdates_ircf(	logical 			ir_dates_only,
									out vector(date) 	pmt_date,									
									out vector(number) 	cpn_rate,
									out vector(number) 	cf_ir,
									out vector(number) 	pv_cf_ir,
									date option(nullable) cut_off)
{
	logical add_exist = prin_add_date_exist();
	if(ir_dates_only || !add_exist){
		 pmt_date 	= pmt_date_ir(cut_off,cut_off_type.PMT_DATE_IR_FWD);
		 cf_ir 		= ir_cf(cut_off,cut_off_type.PMT_DATE_IR_FWD);
		 pv_cf_ir 	= pv_ir_cf(cut_off,cut_off_type.PMT_DATE_IR_FWD);
		 cpn_rate 	= this.cpn_rate(cut_off,cut_off_type.PMT_DATE_IR_FWD);
		 return;
	}
	
	vector(integer) pir_i, pp_i;
	vector(date) pmt_date_all;
	vector(number) cf_ir_all,cf_prin_all,cf_tot_all,cpn_rate_all;
	vector(number) 	pv_cf_ir_all, pv_cf_prin_all, pv_cf_tot_all;
	consolidate_tot_cf_all(pmt_date_all, cf_ir_all,cf_prin_all,cf_tot_all,
						   pv_cf_ir_all, pv_cf_prin_all, pv_cf_tot_all,
						   cpn_rate_all,pir_i, pp_i);

	
	if(null(cut_off) ) {
		pmt_date 	= pmt_date_all;
		cf_ir 		= cf_ir_all;
		pv_cf_ir 	= pv_cf_ir_all;
		cpn_rate 	= cpn_rate_all;
		return;
	}
	
	integer start_i,end_i,n ;
	index_calc_fwd(	pmt_date_all,cut_off, start_i, end_i, n);
	QL_REQUIRE(n>0,"invalid vector size");

	resize(pmt_date,n);
	resize(cf_ir,n);
	resize(pv_cf_ir,n);
	resize(cpn_rate,n);
	
	for(integer j=start_i; j <= end_i; j++) {
		pmt_date[j-start_i] = pmt_date_all[j];
		cf_ir[j-start_i] 	= cf_ir_all[j];
		pv_cf_ir[j-start_i] = pv_cf_ir_all[j];
		cpn_rate[j-start_i] = cpn_rate_all[j];
	}
	
	return ;
}
/*-----------------------------------------------------------------------
  pmtdates_princf
  ----------------------------------------------------------------------*/
void swap_leg_data.pmtdates_princf(	logical 			prin_dates_only,
									out vector(date) 	pmt_date,									
									out vector(number) 	cf_prin,
									out vector(number) 	pv_cf_prin,
									date option(nullable) cut_off)
{
	//logical add_exist = add_date_exist();
	if(prin_dates_only/* || !add_exist*/){
		 pmt_date 	= pmt_date_prin(cut_off,cut_off_type.PMT_DATE_PRIN_FWD);
		 cf_prin 	= this.cf_prin(cut_off,cut_off_type.PMT_DATE_PRIN_FWD);
		 pv_cf_prin = this.pv_cf_prin(cut_off,cut_off_type.PMT_DATE_PRIN_FWD);
		 return;
	}
	
	vector(integer) pir_i, pp_i;
	vector(date) pmt_date_all;
	vector(number) cf_ir_all,cf_prin_all,cf_tot_all;
	vector(number) 	pv_cf_ir_all, pv_cf_prin_all, pv_cf_tot_all, cpn_rate_all;
	consolidate_tot_cf_all(pmt_date_all, cf_ir_all,cf_prin_all,cf_tot_all,
						   pv_cf_ir_all, pv_cf_prin_all, pv_cf_tot_all,cpn_rate_all,pir_i, pp_i);

	
	if(null(cut_off) ) {
		pmt_date = pmt_date_all;
		cf_prin = cf_prin_all;
		pv_cf_prin = pv_cf_prin_all;
		return;
	}
	
	integer start_i,end_i,n ;
	index_calc_fwd(	pmt_date_all,cut_off, start_i, end_i, n);
	QL_REQUIRE(n>0,"invalid vector size");

	resize(pmt_date,n);
	resize(cf_prin,n);
	resize(pv_cf_prin,n);

	for(integer j=start_i; j <= end_i; j++) {
		pmt_date[j-start_i] = pmt_date_all[j];
		cf_prin[j-start_i] = cf_prin_all[j];
		pv_cf_prin[j-start_i] = pv_cf_prin_all[j];
	}

	return ;
}

/*-----------------------------------------------------------------------
  cut_off_calc
  ----------------------------------------------------------------------*/
void 	swap_leg_data.cut_off_calc(logical prin,
								   date cut_off,
								   cut_off_type cut_t,
								   out integer start_i,
								   out integer end_i,
								   out integer n)
{
	start_i = 0;	
	integer s = prin ? v_size(event_date_adj_prin_): v_size(cpn_date_adj_);
	end_i = s-1;
	
	switch(cut_t)
	{	
	case cut_off_type.CPN_DATE_FWD:
		QL_REQUIRE(!prin,"invalid prin flag");
		while(cut_off >= cpn_date_adj_[start_i])
			start_i++;		
		break;
	case cut_off_type.PMT_DATE_IR_FWD:
		QL_REQUIRE(!prin,"invalid prin flag");
		while(cut_off >= pmt_date_ir_[start_i])
			start_i++;		
		break;
	case cut_off_type.CPN_DATE_HIST:
		QL_REQUIRE(!prin,"invalid prin flag");
		while(cut_off < cpn_date_adj_[end_i])
			end_i--;
		break;
	case cut_off_type.PMT_DATE_IR_HIST:
		QL_REQUIRE(!prin,"invalid prin flag");
		while(cut_off < pmt_date_ir_[end_i])
			end_i--;
		break;

	case cut_off_type.PMT_DATE_PRIN_FWD:
		QL_REQUIRE(prin,"invalid prin flag");
		while(cut_off >= pmt_date_prin_[start_i])
			start_i++;
		break;
	case cut_off_type.PMT_DATE_PRIN_HIST:
		QL_REQUIRE(prin,"invalid prin flag");
		while(cut_off < pmt_date_prin_[end_i])
			end_i--;
		break;
	case cut_off_type.ALL:
		break;
	default:
		start_i = end_i = -1;
	}

	n = end_i-start_i+1;
	QL_REQUIRE(n>0,"invalid vector size");
}
/*-----------------------------------------------------------------------
  cut_off_defaults
  ----------------------------------------------------------------------*/
void swap_leg_data.cut_off_defaults(out date cut_off, out cut_off_type cut_t )
{
	if(null(cut_off) || null(cut_t)) {
		cut_off = cpn_date_adj_[0];
		cut_t = cut_off_type.ALL;
	}
}
/*-----------------------------------------------------------------------
  out_number
  ----------------------------------------------------------------------*/
vector(number) swap_leg_data.out_number(logical prin,
										date option(nullable) cut_off,
										cut_off_type option(nullable) cut_t,
										vector(number) v)
{
	cut_off_defaults(cut_off, cut_t );
	
	if(cut_t == cut_off_type.ALL)
		return v;
	
	integer start_i, end_i, n;	
	cut_off_calc(prin, cut_off, cut_t,start_i, end_i, n);

	vector(number) 	r[n];
	for(integer j=start_i; j <= end_i; j++) {
		r[j-start_i] = v[j];
	}
	return r;
}
/*-----------------------------------------------------------------------
  out_date
  ----------------------------------------------------------------------*/
vector(date) swap_leg_data.out_date(logical prin,
									date option(nullable) cut_off,
									cut_off_type option(nullable) cut_t,
									vector(date) v)
{
	cut_off_defaults(cut_off, cut_t );
	
	if(cut_t == cut_off_type.ALL)
		return v;
	integer start_i, end_i, n;	
	cut_off_calc(prin, cut_off, cut_t,start_i, end_i, n);

	vector(date) 	r[n];
	for(integer j=start_i; j <= end_i; j++) {
		r[j-start_i] = v[j];
	}
	return r;
}
/*-----------------------------------------------------------------------
  out_logical
  ----------------------------------------------------------------------*/
vector(logical) swap_leg_data.out_logical(logical prin,
										  date option(nullable) cut_off,
										  cut_off_type option(nullable) cut_t,
										  vector(logical) v)
{
	cut_off_defaults(cut_off, cut_t );
	
	if(cut_t == cut_off_type.ALL)
		return v;
	integer start_i, end_i, n;	
	cut_off_calc(prin, cut_off, cut_t,start_i, end_i, n);

	vector(logical) 	r[n];
	for(integer j=start_i; j <= end_i; j++) {
		r[j-start_i] = v[j];
	}
	return r;
}

/*-----------------------------------------------------------------------
  
  ----------------------------------------------------------------------*/
vector(number) 	swap_leg_data.rate(date option(nullable) cut_off, cut_off_type option(nullable) cut_t )				{ return out_number(false,cut_off, cut_t, rate_);}
vector(number) 	swap_leg_data.cpn_rate(date  option(nullable)cut_off,cut_off_type  option(nullable)cut_t)			{ return out_number(false,cut_off, cut_t, cpn_rate_);}
vector(number) 	swap_leg_data.cf(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)				{ return out_number(false,cut_off, cut_t, cf_);}
vector(number) 	swap_leg_data.pv_cf(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)				{ return out_number(false,cut_off, cut_t, pv_cf_);}
vector(number) 	swap_leg_data.fx_rate(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)			{ return out_number(false,cut_off, cut_t, fx_rate_);}
vector(number) 	swap_leg_data.ir_cf(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)				{ return out_number(false,cut_off, cut_t, ir_cf_);}
vector(number) 	swap_leg_data.pv_ir_cf(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)			{ return out_number(false,cut_off, cut_t, pv_ir_cf_);}
vector(number) 	swap_leg_data.fee(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)				{ return out_number(false,cut_off, cut_t, fee_);}
vector(number) 	swap_leg_data.pv_fee(date option(nullable) cut_off, cut_off_type option(nullable) cut_t) 			{ return out_number(false,cut_off, cut_t, pv_fee_);}
vector(number) 	swap_leg_data.df_value(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)			{ return out_number(false,cut_off, cut_t, df_value_);}
vector(number) 	swap_leg_data.notional(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)			{ return out_number(false,cut_off, cut_t, notional_);}
vector(number)	swap_leg_data.notional_avg(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)		{ return out_number(false,cut_off, cut_t, notional_avg_);}
vector(number) 	swap_leg_data.cpn_notional(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)		{ return out_number(false,cut_off, cut_t, cpn_notional_);}
vector(number) 	swap_leg_data.notional_incr_sink(date option(nullable) cut_off, cut_off_type option(nullable) cut_t) { return out_number(false,cut_off, cut_t, notional_incr_sink_);}
vector(number) 	swap_leg_data.not_multi_fact(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)	{ return out_number(false,cut_off, cut_t, not_multi_fact_);}
vector(date ) 	swap_leg_data.cpn_date(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)			{ return out_date(false,cut_off, cut_t, cpn_date_);}
vector(date ) 	swap_leg_data.cpn_date_adj(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)		{ return out_date(false,cut_off, cut_t, cpn_date_adj_);}
vector(date ) 	swap_leg_data.pmt_date_ir(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)		{ return out_date(false,cut_off, cut_t, pmt_date_ir_);}	
vector(date )  	swap_leg_data.accr_start(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)		{ return out_date(false,cut_off, cut_t, accr_start_);}
vector(date ) 	swap_leg_data.accr_end(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)			{ return out_date(false,cut_off, cut_t, accr_end_);}
vector(number) 	swap_leg_data.accr_per(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)			{ return out_number(false,cut_off, cut_t, accr_per_);}
vector(date ) 	swap_leg_data.ref_start(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)			{ return out_date(false,cut_off, cut_t, ref_start_);}
vector(date ) 	swap_leg_data.ref_end(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)			{ return out_date(false,cut_off, cut_t, ref_end_);}
//prin
vector(date) 	swap_leg_data.event_date_prin(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)		{ return out_date(true,cut_off, cut_t, event_date_prin_);}
vector(date) 	swap_leg_data.event_date_adj_prin(date option(nullable) cut_off, cut_off_type option(nullable) cut_t) 	{ return out_date(true,cut_off, cut_t, event_date_adj_prin_);}
vector(date) 	swap_leg_data.pmt_date_prin(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)			{ return out_date(true,cut_off, cut_t, pmt_date_prin_);}
vector(number) 	swap_leg_data.cf_prin(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)				{ return out_number(true,cut_off, cut_t, cf_prin_);}
vector(number) 	swap_leg_data.pv_cf_prin(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)			{ return out_number(true,cut_off, cut_t, pv_cf_prin_);	}
vector(number) 	swap_leg_data.fx_rate_prin(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)			{ return out_number(true,cut_off, cut_t, fx_rate_prin_);	}
vector(number) 	swap_leg_data.acc_cf_prin(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)			{ return out_number(true,cut_off, cut_t, acc_cf_prin_);}
vector(date) 	swap_leg_data.reset_prin(date option(nullable) cut_off, cut_off_type option(nullable) cut_t)			{ return out_date(true,cut_off, cut_t, reset_prin_);	}
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//  class swap_fix_leg_data
//----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
class swap_fix_leg_data: public swap_leg_data
{
public:
	swap_fix_leg_data(ql_swap_leg);
	swap_fix_leg_data(ql_fix_leg);
private:
	ql_fix_leg 	fix_leg_;
};
/*-----------------------------------------------------------------------
  swap_fix_leg_data constructor
  ----------------------------------------------------------------------*/
swap_fix_leg_data.swap_fix_leg_data(ql_swap_leg leg) : swap_leg_data(leg,IT_SWAPLEG_FIX)
{
	fix_leg_ = dyn_cast_fix_leg(leg_);
}
/*-----------------------------------------------------------------------
  swap_fix_leg_data constructor
  ----------------------------------------------------------------------*/
swap_fix_leg_data.swap_fix_leg_data(ql_fix_leg leg) : swap_leg_data(leg,IT_SWAPLEG_FIX), fix_leg_(leg)
{}

//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//  class swap_fix_infl_ci_leg_data
//----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
class swap_fix_infl_ci_leg_data: public swap_leg_data
{
public:
	swap_fix_infl_ci_leg_data(ql_swap_leg);
	swap_fix_infl_ci_leg_data(ql_fix_infl_ci_leg);
private:
	ql_fix_infl_ci_leg 	fix_leg_;
};
/*-----------------------------------------------------------------------
  swap_fix_infl_ci_leg_data constructor
  ----------------------------------------------------------------------*/
swap_fix_infl_ci_leg_data.swap_fix_infl_ci_leg_data(ql_swap_leg leg) : swap_leg_data(leg,IT_SWAPLEG_FIXINFLCI)
{
	fix_leg_ = dyn_cast_fix_infl_ci_leg(leg_);
}
/*-----------------------------------------------------------------------
  swap_fix_infl_ci_leg_data constructor
  ----------------------------------------------------------------------*/
swap_fix_infl_ci_leg_data.swap_fix_infl_ci_leg_data(ql_fix_infl_ci_leg leg) : swap_leg_data(leg,IT_SWAPLEG_FIXINFLCI), fix_leg_(leg)
{}



//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//  class swap_fix_zero_leg_data
//----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
class swap_fix_zero_leg_data: public swap_leg_data
{
public:
	swap_fix_zero_leg_data(ql_swap_leg);
	swap_fix_zero_leg_data(ql_fix_zero_leg);
private:
	ql_fix_zero_leg 	zero_leg_;
};
/*-----------------------------------------------------------------------
  swap_fix_zero_leg_data constructor
  ----------------------------------------------------------------------*/
swap_fix_zero_leg_data.swap_fix_zero_leg_data(ql_swap_leg leg) : swap_leg_data(leg,instrument_type.IT_SWAPLEG_FIXZERO)
{
	zero_leg_ = dyn_cast_fix_zero_leg(leg_);
}
/*-----------------------------------------------------------------------
  swap_fix_zero_leg_data constructor
  ----------------------------------------------------------------------*/
swap_fix_zero_leg_data.swap_fix_zero_leg_data(ql_fix_zero_leg leg) : swap_leg_data(leg,instrument_type.IT_SWAPLEG_FIXZERO), zero_leg_(leg)
{}

//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//  class swap_zero_infl_leg_data
//----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
class swap_zero_infl_leg_data: public swap_leg_data
{
public:
	swap_zero_infl_leg_data(ql_swap_leg);
	swap_zero_infl_leg_data(ql_zero_infl_leg);
private:
	ql_zero_infl_leg 	infl_leg_;
public:
	
	number	ref_s_;//ip at start
	number	idx_fact_s_;//idx_fact at start (=1 always?)
	number	cpi_0_s_;
	number	cpi_1_s_;
	date cpidt_0_s_;
	date cpidt_1_s_;
	logical	fcast_0_s_;
	logical	fcast_1_s_;
	
	number	ref_e_;
	number	idx_fact_e_;
	number	cpi_0_e_;
	number	cpi_1_e_;
	date cpidt_0_e_;
	date cpidt_1_e_;
	logical	fcast_0_e_;
	logical	fcast_1_e_;

};
/*-----------------------------------------------------------------------
  swap_zero_infl_leg_data constructor
  ----------------------------------------------------------------------*/
swap_zero_infl_leg_data.swap_zero_infl_leg_data(ql_swap_leg leg) : swap_leg_data(leg,instrument_type.IT_SWAPLEG_ZEROINFL)
{
	infl_leg_ = dyn_cast_zero_infl_leg(leg_);
	infl_leg_.event_data_dump(ref_s_,idx_fact_s_,cpi_0_s_,cpi_1_s_,cpidt_0_s_,cpidt_1_s_,fcast_0_s_,fcast_1_s_,
							  ref_e_,idx_fact_e_,cpi_0_e_,cpi_1_e_,cpidt_0_e_,cpidt_1_e_,fcast_0_e_,fcast_1_e_);
}
/*-----------------------------------------------------------------------
  swap_zero_infl_leg_data constructor
  ----------------------------------------------------------------------*/
swap_zero_infl_leg_data.swap_zero_infl_leg_data(ql_zero_infl_leg leg) : swap_leg_data(leg,instrument_type.IT_SWAPLEG_ZEROINFL), infl_leg_(leg)
{
	infl_leg_.event_data_dump(ref_s_,idx_fact_s_,cpi_0_s_,cpi_1_s_,cpidt_0_s_,cpidt_1_s_,fcast_0_s_,fcast_1_s_,
							  ref_e_,idx_fact_e_,cpi_0_e_,cpi_1_e_,cpidt_0_e_,cpidt_1_e_,fcast_0_e_,fcast_1_e_);
}



	
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//  class swap_flt_leg_data
//----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
class swap_flt_leg_data: public swap_leg_data
{
public:
	swap_flt_leg_data(ql_swap_leg, logical);
	swap_flt_leg_data(ql_float_leg, logical);

	vector(date) 	reset_date(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type>   );
	vector(date) 	idx_start_date(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type>  );
	vector(date) 	idx_end_date(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type>   );
	vector(logical) idx_is_regular(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type>  );
	vector(number) 	fix_rate(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type>   );
	vector(logical) is_fixed(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type>  );
	vector(number) 	base_rate(date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type>   );

	void index_dates(out vector(date),out vector(date),out vector(logical),logical = true,
					 date option(nullable) = null<date> ,cut_off_type option(nullable) = null<cut_off_type>  );

	void fixing_data(out vector(date),out vector(number),out vector(logical), logical = false,
					 date option(nullable) = null<date> , cut_off_type option(nullable) = null<cut_off_type>  );
protected:

	swap_flt_leg_data(ql_swap_leg,instrument_type, logical);
	
private:
	
	ql_float_leg 	flt_leg_;

public:	
		
	vector(date) 	reset_date_;
	vector(date) 	idx_start_date_;
	vector(date) 	idx_end_date_;
	vector(logical) is_regular_;
	vector(number) 	fix_rate_;
	vector(logical) is_fixed_;
	vector(number) 	base_rate_;
	logical 		all_dates_;
};
/*-----------------------------------------------------------------------
  swap_flt_leg_data constructor
  ----------------------------------------------------------------------*/
swap_flt_leg_data.swap_flt_leg_data(ql_swap_leg leg,
									logical all_dates) : swap_leg_data(leg,IT_SWAPLEG_FLOAT),
														 all_dates_(all_dates)
{
	flt_leg_ = dyn_cast_float_leg(leg_);
	vector(date) 	cpn_date_adj_ext;
	flt_leg_.event_data_dump(all_dates_,cpn_date_adj_ext,reset_date_,idx_start_date_,idx_end_date_,
							 is_regular_,fix_rate_,is_fixed_,base_rate_);
}
/*-----------------------------------------------------------------------
  swap_flt_leg_data constructor
  ----------------------------------------------------------------------*/
swap_flt_leg_data.swap_flt_leg_data(ql_float_leg leg,
									logical all_dates) : swap_leg_data(leg,IT_SWAPLEG_FLOAT),
														 flt_leg_(leg),all_dates_(all_dates)
{
	vector(date) 	cpn_date_adj_ext;
	flt_leg_.event_data_dump(all_dates_,cpn_date_adj_ext,reset_date_,idx_start_date_,idx_end_date_,
							 is_regular_,fix_rate_,is_fixed_,base_rate_);
}
/*-----------------------------------------------------------------------
  swap_flt_leg_data constructor prot
  ----------------------------------------------------------------------*/
swap_flt_leg_data.swap_flt_leg_data(ql_swap_leg leg,
									instrument_type type,
									logical all_dates) : swap_leg_data(leg,type),
														 all_dates_(all_dates)
{
}
/*-----------------------------------------------------------------------
  out_number_ext
  ----------------------------------------------------------------------*/
/*vector(number) swap_flt_leg_data.out_number_ext(date cut_off,
												cut_off_type cut_t,
												vector(number) v)
{
	if(cut_t == cut_off_type.ALL)
		return v;
	integer start_i, end_i, n;	
	cut_off_calc(false, cut_off, cut_t,start_i, end_i, n);

	vector(date) 	cd[n];
	for(integer j=start_i; j <= end_i; j++) {		
		cd[j-start_i] = cpn_date_adj_[j];
	}
	vector(integer) vi = v_find(cpn_date_adj_ext_, cd);	
	return sub_vector(v,vi);
}*/

/*-----------------------------------------------------------------------
  out_date_ext
  ----------------------------------------------------------------------*/
/*vector(date) swap_flt_leg_data.out_date_ext(date cut_off,
											cut_off_type cut_t,
											vector(date) v)
{
	if(cut_t == cut_off_type.ALL)
		return v;
	integer start_i, end_i, n;	
	cut_off_calc(false, cut_off, cut_t,start_i, end_i, n);

	vector(date) 	cd[n];
	for(integer j=start_i; j <= end_i; j++) {		
		cd[j-start_i] = cpn_date_adj_[j];
	}
	vector(integer) vi = v_find(cpn_date_adj_ext_, cd);	
	return sub_vector(v,vi);
}*/
/*-----------------------------------------------------------------------
  out_logical_ext
  ----------------------------------------------------------------------*/
/*vector(logical) swap_flt_leg_data.out_logical_ext(date cut_off,
												  cut_off_type cut_t,
												  vector(logical) v)
{
	if(cut_t == cut_off_type.ALL)
		return v;
	integer start_i, end_i, n;	
	cut_off_calc(false, cut_off, cut_t,start_i, end_i, n);

	vector(date) 	cd[n];
	for(integer j=start_i; j <= end_i; j++) {		
		cd[j-start_i] = cpn_date_adj_[j];
	}
	vector(integer) vi = v_find(cpn_date_adj_ext_, cd);	
	return sub_vector(v,vi);
}*/
/*-----------------------------------------------------------------------
  
  ----------------------------------------------------------------------*/
vector(date) swap_flt_leg_data.reset_date(date option(nullable)cut_off, cut_off_type option(nullable)cut_t)			{ return out_date(false,cut_off, cut_t, reset_date_);}
vector(date) swap_flt_leg_data.idx_start_date(date option(nullable)cut_off, cut_off_type option(nullable)cut_t)		{ return out_date(false,cut_off, cut_t, idx_start_date_);}
vector(date) swap_flt_leg_data.idx_end_date(date option(nullable)cut_off, cut_off_type option(nullable)cut_t) 		{ return out_date(false,cut_off, cut_t, idx_end_date_);}
vector(logical) swap_flt_leg_data.idx_is_regular(date option(nullable)cut_off, cut_off_type option(nullable)cut_t) 	{ return out_logical(false,cut_off, cut_t, is_regular_);}
vector(number) swap_flt_leg_data.fix_rate(date option(nullable)cut_off, cut_off_type option(nullable)cut_t) 		{ return out_number(false,cut_off, cut_t, fix_rate_);}
vector(logical) swap_flt_leg_data.is_fixed(date option(nullable)cut_off, cut_off_type option(nullable)cut_t) 		{ return out_logical(false,cut_off, cut_t, is_fixed_);}
vector(number) 	swap_flt_leg_data.base_rate(date option(nullable)cut_off, cut_off_type option(nullable)cut_t) 		{ return out_number(false,cut_off, cut_t, base_rate_);}

/*-----------------------------------------------------------------------
  index_dates
  ----------------------------------------------------------------------*/
void swap_flt_leg_data.index_dates(	out vector(date) 	index_start_dates,
									out vector(date) 	index_end_dates,
									out vector(logical)  index_regular,
									logical 			all_dates,
									date option(nullable) cut_off,									
									cut_off_type option(nullable) cut_t)
{
	index_start_dates 	= idx_start_date( cut_off,  cut_t);
	index_end_dates 	= idx_end_date( cut_off,  cut_t);
	index_regular 		= idx_is_regular( cut_off,  cut_t);
	return;
}

/*-----------------------------------------------------------------------
  fixing_data
  ----------------------------------------------------------------------*/
void swap_flt_leg_data.fixing_data(	out vector(date)  		reset_date,									
									out vector(number)  	fix_rate,
									out vector(logical) 	is_fixed,
									logical 				only_fixed,
									date option(nullable) 	cut_off,
									cut_off_type option(nullable) cut_t )
{
	if(only_fixed) {
		vector(integer) vi = v_find(this.is_fixed( cut_off,  cut_t), true);		
		reset_date 	= sub_vector(this.reset_date( cut_off,  cut_t),vi); 
		fix_rate 	= sub_vector(this.fix_rate( cut_off,  cut_t),vi);
		is_fixed 	= sub_vector(this.is_fixed( cut_off,  cut_t),vi);
		return;
	}
	
	reset_date 	= this.reset_date( cut_off,  cut_t);
	fix_rate 	= this.fix_rate( cut_off,  cut_t);
	is_fixed 	= this.is_fixed( cut_off,  cut_t);
	return;
}
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//  class swap_ois_leg_data
//----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
class swap_ois_leg_data: public swap_flt_leg_data
{
public:
	swap_ois_leg_data(ql_swap_leg,logical);
	swap_ois_leg_data(ql_ois_leg,logical);
private:
	ql_ois_leg 	ois_leg_;

};
/*-----------------------------------------------------------------------
  swap_ois_leg_data constructor
  ----------------------------------------------------------------------*/
swap_ois_leg_data.swap_ois_leg_data(ql_swap_leg leg,
									logical all_dates) : swap_flt_leg_data(leg,IT_SWAPLEG_OIS,all_dates)
{
	ois_leg_ = dyn_cast_ois_leg(leg_);
	vector(date) 	cpn_date_adj_ext;
	ois_leg_.event_data_dump(all_dates_,cpn_date_adj_ext,reset_date_,idx_start_date_,idx_end_date_,is_regular_,fix_rate_,is_fixed_,base_rate_);
}
/*-----------------------------------------------------------------------
  swap_ois_leg_data constructor
  ----------------------------------------------------------------------*/
swap_ois_leg_data.swap_ois_leg_data(ql_ois_leg leg,
									logical all_dates) : swap_flt_leg_data(leg,IT_SWAPLEG_OIS,all_dates), ois_leg_(leg)
{
	vector(date) 	cpn_date_adj_ext;
	ois_leg_.event_data_dump(all_dates_,cpn_date_adj_ext,reset_date_,idx_start_date_,idx_end_date_,is_regular_,fix_rate_,is_fixed_,base_rate_);
}

