
/*	
	Extended curve
	Developed by Algorithmica Research, Magnus Nyström
			
	ToDo: WORK-IN-PROGRESS

	Comments:	

*/


/*-----------------------------------------------------------------------
  Name :    class curve_ext_parm
  Notes :   mostly a container for params        
  Changes:
  			Date    		Who     Detail
  ----------------------------------------------------------------------*/
class curve_ext_parm option (category: 'Yield Curve')
{
	
	public:
	
		curve_ext_parm(	curve option(nullable), curve option(nullable), curve option(nullable), 
						logical,logical,logical,curve_prio,curve_prio,integer);
	
		curve_ext_parm(	curve option(nullable), curve option(nullable), curve option(nullable), 
						logical,logical,logical,curve_prio,curve_prio, 
						integer,vector(number) option(nullable),vector(number) option(nullable),
						vector(number) option(nullable));
		
		curve_ext_parm(	curve option(nullable), curve option(nullable) , vector(number) option(nullable), curve option(nullable), 
						logical,logical,logical,curve_prio,curve_prio, integer);//ir fut constructor
		
		curve_ext_parm(	curve option(nullable), curve option(nullable) , vector(number) option(nullable), curve option(nullable), 
						logical,logical,logical,curve_prio,curve_prio, integer,
						vector(number) option(nullable),vector(number) option(nullable),
						vector(number) option(nullable));//ir fut constructor
		
		curve_ext_parm(	curve_ext_parm);

		curve  				short_crv();
		curve  				middle_crv(); 
		curve  				long_crv();					
		logical 			no_overlap_fwd();
		logical 			merge_middle();
		logical				merge_crv();
		curve_prio 			prio1();
		curve_prio 			prio2();		
		integer				blend_buf_days();
		curve_blend_parm 	blend_parm();
		vector(number) 		irfut_cvx_adj();
		
		virtual void		set_prio_order(logical orig);		
		virtual void 		set_short_crv(curve option(nullable));
		void 				set_middle_crv(curve option(nullable));
		void 				set_long_crv(curve option(nullable));
		void				set_irfut_crv(curve option(nullable) ,vector(number) option(nullable));
		virtual string 		ccy();
		virtual calendar 	cal();
		virtual date		trade_date();
	protected:
				
		curve_ext_parm(	curve option(nullable), curve option(nullable) , vector(number) option(nullable), curve option(nullable), 
						logical,logical,logical,curve_prio,curve_prio, integer, logical );//ir fut constructor
		curve_ext_parm(	curve option(nullable), curve option(nullable) , vector(number) option(nullable), curve option(nullable), 
						logical,logical,logical,curve_prio,curve_prio, integer,
						vector(number) option(nullable),vector(number) option(nullable),
						vector(number) option(nullable), logical );//ir fut constructor
		
		void				init_cvx_adj();
		void				init_adj(out curve option(nullable),vector(number) option(nullable), logical);
		
		curve  			short_crv_;
		curve  			middle_crv_; 
		curve  			long_crv_;					
		logical 		no_overlap_fwd_;
		logical 		merge_middle_;
		logical			merge_crv_;
		curve_prio 		prio1_;
		curve_prio 		prio2_;		
		integer			blend_buf_days_;	
		curve  			orig_middle_crv_;
		vector(number) 	irfut_cvx_adj_;
		vector(string) 	irfut_names_;
		curve_prio 		orig_prio1_;
		curve_prio 		orig_prio2_;	
									
};
//constructor for irfut in the curve
curve_ext_parm.curve_ext_parm(	curve option(nullable) 		short_crv,											
								curve  option(nullable) 	irfut_crv,
								vector(number) option(nullable) irfut_cvx_adj,
								curve option(nullable)		long_crv,									
								logical						no_overlap_fwd,
								logical						merge_irfut,
								logical						merge_crv,
								curve_prio					prio1,
								curve_prio					prio2,
								integer						blend_buf_days,
								logical 					run_prio)//protected constructor
								:short_crv_(short_crv), middle_crv_(irfut_crv),long_crv_(long_crv), 
								 no_overlap_fwd_(no_overlap_fwd),merge_middle_(merge_irfut), merge_crv_(merge_crv), prio1_(prio1), 
								 prio2_(prio2), blend_buf_days_(blend_buf_days),
								 orig_middle_crv_(irfut_crv),
								 irfut_cvx_adj_(CORE_INT.clone_vector(irfut_cvx_adj)), 								
								 irfut_names_(null<vector(string)>),
								 orig_prio1_(prio1), orig_prio2_(prio2)
{
	init_cvx_adj();
	if(run_prio)
		set_prio_order(false);
}

curve_ext_parm.curve_ext_parm(	curve option(nullable) 		short_crv,											
								curve  option(nullable) 	irfut_crv,
								vector(number) option(nullable) irfut_cvx_adj,
								curve option(nullable)		long_crv,									
								logical						no_overlap_fwd,
								logical						merge_irfut,
								logical						merge_crv,
								curve_prio					prio1,
								curve_prio					prio2,
								integer						blend_buf_days) 
								:short_crv_(short_crv), middle_crv_(irfut_crv),long_crv_(long_crv), 
								 no_overlap_fwd_(no_overlap_fwd),merge_middle_(merge_irfut), merge_crv_(merge_crv), prio1_(prio1), 
								 prio2_(prio2), blend_buf_days_(blend_buf_days),
								 orig_middle_crv_(irfut_crv),
								 irfut_cvx_adj_(CORE_INT.clone_vector(irfut_cvx_adj)), 								
								 irfut_names_(null<vector(string)>),
								 orig_prio1_(prio1), orig_prio2_(prio2)
{
	init_cvx_adj();
	set_prio_order(false);
}

curve_ext_parm.curve_ext_parm(	curve option(nullable) 		short_crv,											
								curve option(nullable) 		irfut_crv,
								vector(number) option(nullable) irfut_cvx_adj,
								curve option(nullable)		long_crv,
								logical						no_overlap_fwd,
								logical						merge_middle,
								logical						merge_crv,
								curve_prio					prio1,
								curve_prio					prio2,
								integer						blend_buf_days, 
								vector(number) option(nullable) short_crv_y_spr,
								vector(number) option(nullable) irfut_crv_y_spr,
								vector(number) option(nullable) long_crv_y_spr,
								logical 					run_prio)//protected constructor
								:short_crv_(short_crv), middle_crv_(irfut_crv),long_crv_(long_crv),
								 no_overlap_fwd_(no_overlap_fwd),merge_middle_(merge_middle), merge_crv_(merge_crv), prio1_(prio1), 
								 prio2_(prio2), blend_buf_days_(blend_buf_days),
								 orig_middle_crv_(null<curve>), irfut_cvx_adj_(null<vector(number)>), irfut_names_(null<vector(string)>),
								 orig_prio1_(prio1), orig_prio2_(prio2)
{
	init_adj(short_crv_, short_crv_y_spr, true);
	init_adj(irfut_crv, irfut_crv_y_spr, true);
	init_adj(long_crv_, long_crv_y_spr, true);
	init_cvx_adj();
	if(run_prio)
		set_prio_order(false);
}

curve_ext_parm.curve_ext_parm(	curve option(nullable) 		short_crv,											
								curve option(nullable) 		irfut_crv,
								vector(number) option(nullable) irfut_cvx_adj,
								curve option(nullable)		long_crv,
								logical						no_overlap_fwd,
								logical						merge_middle,
								logical						merge_crv,
								curve_prio					prio1,
								curve_prio					prio2,
								integer						blend_buf_days, 
								vector(number) option(nullable) short_crv_y_spr,
								vector(number) option(nullable) irfut_crv_y_spr,
								vector(number) option(nullable) long_crv_y_spr) 
								:short_crv_(short_crv), middle_crv_(irfut_crv),long_crv_(long_crv),
								 no_overlap_fwd_(no_overlap_fwd),merge_middle_(merge_middle), merge_crv_(merge_crv), prio1_(prio1), 
								 prio2_(prio2), blend_buf_days_(blend_buf_days),
								 orig_middle_crv_(null<curve>), irfut_cvx_adj_(null<vector(number)>), irfut_names_(null<vector(string)>),
								 orig_prio1_(prio1), orig_prio2_(prio2)
{
	init_adj(short_crv_, short_crv_y_spr, true);
	init_adj(irfut_crv, irfut_crv_y_spr, true);
	init_adj(long_crv_, long_crv_y_spr, true);
	init_cvx_adj();
	set_prio_order(false);
}

curve_ext_parm.curve_ext_parm(	curve option(nullable) 		short_crv,											
								curve option(nullable) 		middle_crv,
								curve option(nullable)		long_crv,									
								logical						no_overlap_fwd,
								logical						merge_middle,
								logical						merge_crv,
								curve_prio					prio1,
								curve_prio					prio2,
								integer						blend_buf_days ) 
								:short_crv_(short_crv), middle_crv_(middle_crv),long_crv_(long_crv), 
								 no_overlap_fwd_(no_overlap_fwd),merge_middle_(merge_middle), merge_crv_(merge_crv), prio1_(prio1), 
								 prio2_(prio2), blend_buf_days_(blend_buf_days),
								 orig_middle_crv_(null<curve>), irfut_cvx_adj_(null<vector(number)>), irfut_names_(null<vector(string)>),
								 orig_prio1_(prio1), orig_prio2_(prio2)
{
	set_prio_order(false);
}

curve_ext_parm.curve_ext_parm(	curve option(nullable) 		short_crv,											
								curve option(nullable) 		middle_crv,
								curve option(nullable)		long_crv,
								logical						no_overlap_fwd,
								logical						merge_middle,
								logical						merge_crv,
								curve_prio					prio1,
								curve_prio					prio2,
								integer						blend_buf_days, 
								vector(number) option(nullable) short_crv_y_spr,
								vector(number) option(nullable) middle_crv_y_spr,
								vector(number) option(nullable) long_crv_y_spr) 
								:short_crv_(short_crv), middle_crv_(middle_crv),long_crv_(long_crv),
								 no_overlap_fwd_(no_overlap_fwd),merge_middle_(merge_middle), merge_crv_(merge_crv), prio1_(prio1), 
								 prio2_(prio2), blend_buf_days_(blend_buf_days),
								 orig_middle_crv_(null<curve>), irfut_cvx_adj_(null<vector(number)>), irfut_names_(null<vector(string)>),
								 orig_prio1_(prio1), orig_prio2_(prio2)
{
	init_adj(short_crv_, short_crv_y_spr, true);
	init_adj(middle_crv_, middle_crv_y_spr, true);
	init_adj(long_crv_, long_crv_y_spr, true);
	set_prio_order(false);
}

curve_ext_parm.curve_ext_parm(curve_ext_parm s) 
										:short_crv_(s.short_crv_), middle_crv_(s.middle_crv_),long_crv_(s.long_crv_), 
										 no_overlap_fwd_(s.no_overlap_fwd_), merge_middle_(s.merge_middle_), merge_crv_(s.merge_crv_), prio1_(s.prio1_), 
										 prio2_(s.prio2_), blend_buf_days_(s.blend_buf_days_),										 																		
										 orig_middle_crv_(s.orig_middle_crv_),
										 irfut_cvx_adj_(CORE_INT.clone_vector(s.irfut_cvx_adj_)), 
										 irfut_names_(CORE_INT.clone_vector(s.irfut_names_)),
										 orig_prio1_(s.orig_prio1_), orig_prio2_(s.orig_prio2_)
{}

curve  		curve_ext_parm.short_crv() 			{ return short_crv_;}
curve  		curve_ext_parm.middle_crv()			{ return middle_crv_;} 
curve  		curve_ext_parm.long_crv()			{ return long_crv_;}					
logical 	curve_ext_parm.no_overlap_fwd()		{ return no_overlap_fwd_;}
logical 	curve_ext_parm.merge_middle()		{ return merge_middle_;}
logical		curve_ext_parm.merge_crv()			{ return merge_crv_;}
curve_prio 	curve_ext_parm.prio1()				{ return prio1_;}
curve_prio 	curve_ext_parm.prio2()				{ return prio2_;}		
integer		curve_ext_parm.blend_buf_days()		{ return blend_buf_days_;}
vector(number) 	curve_ext_parm.irfut_cvx_adj()	{ return irfut_cvx_adj_;}
		
curve_blend_parm curve_ext_parm.blend_parm()
{
	return new curve_blend_parm(prio1_,prio2_,no_overlap_fwd_,merge_middle_,merge_crv_,blend_buf_days_);
}

void curve_ext_parm.set_prio_order(logical use_orig)
{
	if(use_orig){
		prio1_ = orig_prio1_;
		prio2_ = orig_prio2_;
	}
	CORE_INT.set_prio_order(short_crv_,middle_crv_,long_crv_,prio1_,prio2_);
}

void curve_ext_parm.set_short_crv(curve option(nullable) s) 	{ short_crv_ = s; set_prio_order(true);}
void curve_ext_parm.set_long_crv(curve option(nullable) s) 		{ long_crv_ = s; set_prio_order(true);}

void curve_ext_parm.set_middle_crv(curve option(nullable) f)
{
	middle_crv_ 		= f;
	orig_middle_crv_ 	= null<curve>;
	irfut_cvx_adj_ 		= null<vector(number)>;
	set_prio_order(true);
}

void curve_ext_parm.set_irfut_crv(curve option(nullable) f,
								  vector(number) option(nullable) irfut_cvx_adj)
{
	middle_crv_ 		= f;
	orig_middle_crv_ 	= f;
	irfut_cvx_adj_		= CORE_INT.clone_vector(irfut_cvx_adj);
	init_cvx_adj();
	set_prio_order(true);
}

//-------------------------------------------------------
// init_adj
//-------------------------------------------------------
void curve_ext_parm.init_adj(	out curve  						crv, //change in place
								vector(number) option(nullable) adj, 
								logical 						is_y)
{
	if(!check_curve(crv) || null(adj) || v_size(adj) == 0)
		return;

	vector(instrument) v_crv_i 	= crv.instruments();
	integer crv_size 			= v_size(v_crv_i);		
	integer adj_size 			= v_size(adj);

	if(adj_size > 1)
		QL_REQUIRE(v_size(adj) == crv_size,'invalid size of adjustment vector (should be same size as # instruments in curve or size = 1 (if not null))');
	
	logical is_adj = false;
	for(integer i = 0; i < crv_size; i++){
		number a = adj_size == 1 ? adj[0] : adj[i];

		if(null(a) || CORE_INT.is_equal_zero(a) ){			
			continue;
		}
				
		if(is_y)			
			v_crv_i[i] = v_crv_i[i].set_yield(v_crv_i[i].yield() + a);				
		else
			v_crv_i[i] = v_crv_i[i].set_quote(v_crv_i[i].quote() + a);
		
		is_adj = true;			
				
	}
	if(is_adj)
		crv = curve(v_crv_i, crv.name());			
}

//-------------------------------------------------------
// init_cvx_adj  (called only from constructors for ir futures)
//-------------------------------------------------------
void curve_ext_parm.init_cvx_adj()
{
	if(null(irfut_cvx_adj_) || v_size(irfut_cvx_adj_) == 0){
		return;
	}
	
	logical ok = check_curve(middle_crv_);
	if(!ok) {
		irfut_cvx_adj_ = null<vector(number)>;
		return ;
	}
	
	vector(instrument) v_irfut_i 	= middle_crv_.instruments();
	integer irfut_size 				= v_size(v_irfut_i);
		
	QL_REQUIRE(v_size(irfut_cvx_adj_) == irfut_size,'invalid size of convexity adjustment vector (should be same size as # instruments in middle curve)');

	resize(irfut_names_,irfut_size);
	
	logical adj = false;
	for(integer i = 0; i < irfut_size; i++){

		if(!v_irfut_i[i].is_ir_future()) {
			irfut_cvx_adj_[i] = null<number>;
			irfut_names_[i] = "";
			continue;
		}

		irfut_names_[i] = str_to_upper(v_irfut_i[i].name());
		
		if(null(irfut_cvx_adj_[i]) || CORE_INT.is_equal_zero(irfut_cvx_adj_[i]) ){
			irfut_cvx_adj_[i] = 0;			
			continue;
		}
				
		number y = v_irfut_i[i].yield();
		QL_REQUIRE(!null(y),"invalid yield",v_irfut_i[i].name(),true);			
		v_irfut_i[i] = v_irfut_i[i].set_yield(y - irfut_cvx_adj_[i]);				
		adj = true;						
	}
	if(adj)
		middle_crv_ = curve(v_irfut_i, strcat(middle_crv_.name(),"-cvxadj"));			
}

//-------------------------------------------------------
// ccy
//-------------------------------------------------------
string curve_ext_parm.ccy()
{
	if(check_curve(short_crv())){		
		return short_crv().instruments()[0].currency();					
	}
	else if(check_curve(middle_crv())){
		return  middle_crv().instruments()[0].currency();						
	}
	else if(check_curve(long_crv())){
		return long_crv().instruments()[0].currency();					
	}
	else {
		return null<string>;
	}
}
//-------------------------------------------------------
// cal
//-------------------------------------------------------
calendar curve_ext_parm.cal()
{
	if(check_curve(short_crv())){		
		return short_crv().instruments()[0].calendar();					
	}
	else if(check_curve(middle_crv())){
		return  middle_crv().instruments()[0].calendar();						
	}
	else if(check_curve(long_crv())){
		return long_crv().instruments()[0].calendar();					
	}
	else {
		return null<calendar>;
	}
}
//-------------------------------------------------------
// cal
//-------------------------------------------------------
date curve_ext_parm.trade_date()
{
	if(check_curve(short_crv())){		
		return short_crv().instruments()[0].trade_date();					
	}
	else if(check_curve(middle_crv())){
		return  middle_crv().instruments()[0].trade_date();						
	}
	else if(check_curve(long_crv())){
		return long_crv().instruments()[0].trade_date();					
	}
	else {
		return null<date>;
	}
}
//-------------------------------------------------------
// create curve_ext_parm
//-------------------------------------------------------
curve_ext_parm curve_ext_parm(	curve option(nullable) 		short_crv,											
								curve  option(nullable) 	irfut_crv,
								vector(number) option(nullable) irfut_cvx_adj,
								curve option(nullable)		long_crv,									
								logical						no_overlap_fwd,
								logical						merge_irfut,
								logical						merge_crv,
								curve_prio					prio1,
								curve_prio					prio2,
								integer						blend_buf_days) 								
{
	return new curve_ext_parm(short_crv, irfut_crv, irfut_cvx_adj, long_crv,  no_overlap_fwd, merge_irfut,
									merge_crv, prio1, prio2, blend_buf_days);	
}

//-------------------------------------------------------
// create curve_ext_parm
//-------------------------------------------------------
curve_ext_parm curve_ext_parm(	curve option(nullable) 		short_crv,											
								curve  option(nullable) 	irfut_crv,
								vector(number) option(nullable) irfut_cvx_adj,
								curve option(nullable)		long_crv,									
								logical						no_overlap_fwd,
								logical						merge_irfut,
								logical						merge_crv,
								curve_prio					prio1,
								curve_prio					prio2,
								integer						blend_buf_days, 
								vector(number) option(nullable) short_crv_y_spr,
								vector(number) option(nullable) irfut_crv_y_spr,
								vector(number) option(nullable) long_crv_y_spr) 								
{
	return new curve_ext_parm(	short_crv, irfut_crv, irfut_cvx_adj, long_crv,  no_overlap_fwd, merge_irfut,
								merge_crv, prio1, prio2, blend_buf_days,short_crv_y_spr,
								irfut_crv_y_spr, long_crv_y_spr);
}	
//-------------------------------------------------------
// create curve_ext_parm
//-------------------------------------------------------
curve_ext_parm curve_ext_parm(	curve option(nullable) 		short_crv,											
								curve  option(nullable) 	middle_crv,
								curve option(nullable)		long_crv,									
								logical						no_overlap_fwd,
								logical						merge_middle,
								logical						merge_crv,
								curve_prio					prio1,
								curve_prio					prio2,
								integer						blend_buf_days) 								
{
	return new curve_ext_parm(short_crv, middle_crv, long_crv,  no_overlap_fwd, merge_middle,
									merge_crv, prio1, prio2, blend_buf_days);	
}

//-------------------------------------------------------
// create curve_ext_parm
//-------------------------------------------------------
curve_ext_parm curve_ext_parm(	curve option(nullable) 		short_crv,											
								curve  option(nullable) 	middle_crv,
								curve option(nullable)		long_crv,									
								logical						no_overlap_fwd,
								logical						merge_middle,
								logical						merge_crv,
								curve_prio					prio1,
								curve_prio					prio2,
								integer						blend_buf_days, 
								vector(number) option(nullable) short_crv_y_spr,
								vector(number) option(nullable) middle_crv_y_spr,
								vector(number) option(nullable) long_crv_y_spr) 								
{
	return new curve_ext_parm(	short_crv, middle_crv, long_crv,  no_overlap_fwd, merge_middle,
								merge_crv, prio1, prio2, blend_buf_days,short_crv_y_spr,
								middle_crv_y_spr, long_crv_y_spr);
}


//-------------------------------------------------------
// create curve_ext_parm
//-------------------------------------------------------
curve_ext_parm curve_ext_parm(	curve option(nullable) 		short_crv,											
								curve  option(nullable) 	middle_crv,
								curve option(nullable)		long_crv,									
								curve_blend_parm			crv_blend_parm, 
								vector(number) option(nullable) short_crv_y_spr,
								vector(number) option(nullable) middle_crv_y_spr,
								vector(number) option(nullable) long_crv_y_spr) 								
{

	return new curve_ext_parm(	short_crv, middle_crv, long_crv,  crv_blend_parm.no_overlap_fwd_, 
								crv_blend_parm.merge_middle_,crv_blend_parm.merge_crv_, crv_blend_parm.prio1_, 
								crv_blend_parm.prio2_, crv_blend_parm.blend_buf_days_, short_crv_y_spr,
								middle_crv_y_spr, long_crv_y_spr);
}

/*-----------------------------------------------------------------------
  Name :    class curve_ext
  Notes :           
  Changes:
  			Date    		Who     Detail
  ----------------------------------------------------------------------*/
class curve_ext option (category: 'Yield Curve')
{   	
	public:
		curve_ext(curve_ext_parm, date option(nullable) , string );
		curve					blended_curve();
		curve					blended_curve(instr_type);
		string					name();
		virtual curve			short_curve();
		virtual curve			middle_curve();
		virtual curve			long_curve();
		virtual date			curve_end();		
		logical 				check(out string);
		virtual disc_func 		disc_df(disc_z_model );
		virtual disc_func 		disc_df(disc_func,disc_z_model );
		virtual curve_ext_parm 	param();
		virtual date 			trade_date();
	protected:
		curve_ext(curve_ext_parm, date option(nullable), string, logical );
		curve_ext(curve_ext) ;
		void 		init();
		void 		check();
		void 		blend();
		logical		curve_ok();
		
		string					name_;
		curve_ext_parm 			p_;
		date					d_;						
		curve  					curve_;		
		string					curve_msg_;
				
};

//-------------------------------------------------------
// constructor 
//-------------------------------------------------------
curve_ext.curve_ext(curve_ext_parm		p,
					date	option(nullable) d,																									
					string 				name) 
					:name_(name), p_(p),d_(d), curve_(null<curve>), curve_msg_("no_init")
{
	if(null(d_))
	   d_ = p_.trade_date();
	init();
}
//-------------------------------------------------------
// constructor 
//-------------------------------------------------------
curve_ext.curve_ext(curve_ext_parm		p,
					date option(nullable) d,																									
					string 				name,
					logical 			run_init)
					:name_(name), p_(p),d_(d), curve_(null<curve>), curve_msg_("no_init")
{
	if(null(d_))
	   d_ = p.trade_date();
	   
	if(run_init)
		init();
}
//-------------------------------------------------------
// copy constructor
//-------------------------------------------------------
curve_ext.curve_ext(curve_ext s) 
					:name_(s.name_), p_(s.p_), d_(s.d_),
					 curve_(s.curve_),curve_msg_(s.curve_msg_)
{}

//-------------------------------------------------------
// init
//-------------------------------------------------------
void curve_ext.init()
{
	check();
	blend();						
}
//-------------------------------------------------------
// check
//-------------------------------------------------------
void curve_ext.check()
{		
	string ccy = null<string>;
	if(check_curve(p_.short_crv())){
		string err_name;		
		QL_REQUIRE(CORE_INT.check_eq_currency(p_.short_crv().instruments(), ccy, err_name),'invalid short curve (mixed currencies)', err_name, true);					
	}
	if(check_curve(p_.middle_crv())){
		string err_name;
		QL_REQUIRE(CORE_INT.check_eq_currency(p_.middle_crv().instruments(), ccy, err_name),'invalid middle curve (mixed currencies)', err_name, true);						
	}
	if(check_curve(p_.long_crv())){
		string err_name;	
		QL_REQUIRE(CORE_INT.check_eq_currency(p_.long_crv().instruments(), ccy, err_name),'invalid long curve (mixed currencies)', err_name, true);					
	}						
}

//-------------------------------------------------------
// blend
//-------------------------------------------------------
void curve_ext.blend()
{
	curve_ = CORE_INT.blender_adj_long_curve(	p_.short_crv(), p_.middle_crv() , p_.long_crv(), p_.prio1(), 
												p_.prio2(),p_.merge_middle(), p_.merge_crv(), p_.no_overlap_fwd(),
												p_.blend_buf_days());

	if(null(curve_)) {
		curve_msg_ 	= "null curve (curve_ext-blend)";		
		return;
	}

	curve_ = curve_.set_name(strcat(name_,":blended curve"));
	
	string n;
	logical nq = check_quote(curve_,n);

	if(!nq) {
		curve_msg_ = strcat(["null quotes in curve (curve_ext-blend) [",n,"]"]);
		//curve_msg_ 	= "null quotes in curve (curve_ext-blend)";		
		return;
	}
	
	curve_msg_ 	= check_curve(curve_) ? "" : "empty curve (curve_ext-blend)";		
}

logical 	curve_ext.curve_ok() 				{ return curve_msg_ == "";}
logical 	curve_ext.check(out string err_msg) { err_msg = curve_msg_; return curve_ok();}
curve 		curve_ext.blended_curve()			{ return curve_ ;}
curve		curve_ext.short_curve() 			{ return p_.short_crv();}
curve		curve_ext.middle_curve() 			{ return p_.middle_crv();}
curve		curve_ext.long_curve() 				{ return p_.long_crv();}
string		curve_ext.name() 					{ return name_;}
date 		curve_ext.trade_date()				{ return d_;}
curve_ext_parm  curve_ext.param() 				{ return p_;}
//-------------------------------------------------------
// blended_curve
//-------------------------------------------------------
curve curve_ext.blended_curve(instr_type it)
{
	if(!curve_ok())
		return null<curve>;

	vector(instrument) vi = curve_.instruments();
	vector(instrument) res[0];
	
	for(integer i=0; i < v_size(vi); i++){
		if(vi[i].is_instr_type(it)) {
			push_back(res,vi[i]);
		}
	}
	return curve(res);
}

//-------------------------------------------------------
// curve_end
//-------------------------------------------------------
date curve_ext.curve_end()
{ 
	if(!curve_ok())
		return null<date>;
	return v_max(curve_.instruments().maturity());
}

//-------------------------------------------------------
// disc_df
//-------------------------------------------------------
disc_func curve_ext.disc_df(disc_z_model disc_model)							   
{	
	if(!curve_ok())
		return null<disc_func>;
	return disc_model.df(curve_, null<vector(number)>);												
}
//-------------------------------------------------------
// disc_df
//-------------------------------------------------------
disc_func curve_ext.disc_df(disc_func df_base, disc_z_model disc_model)							   
{	
	if(!curve_ok())
		return null<disc_func>;
	return disc_model.df(df_base, curve_, null<vector(number)>);												
}
//-------------------------------------------------------
// create curve_ext
//-------------------------------------------------------
curve_ext curve_ext(curve_ext_parm	p,
					date option(nullable) d,
					string 			name) 
										
{					
	curve_ext c = new curve_ext(p, d, name);

	return c;
}