option(null: hard);	

/*	
	Basic swap functions for "dual" bootstrap
	Parameter classes
	Developed by Algorithmica Research, Magnus Nyström
			
	Comments:

	ToDo: 
	
*/


/*-----------------------------------------------------------------------
  Name :    class swap_curve_b2_f_parm
  Notes :           
  Changes:
  			Date    		Who     Detail
  			2-Aug-2016 		MN      
  ----------------------------------------------------------------------*/
class swap_curve_b2_f_parm : public  swap_curve_fwd_f_parm option (category: 'Yield Curve/003 Curve Building')
{
   	public:
		swap_curve_b2_f_parm(fixing_curve option(nullable), curve option(nullable), curve, curve , 
							curve_blend_parm,vector(number) option(nullable),vector(number) option(nullable),
							vector(number) option(nullable),vector(number) option(nullable));			

		swap_curve_b2_f_parm(curve option(nullable), curve option(nullable), curve, curve , 
							curve_blend_parm,vector(number) option(nullable),vector(number) option(nullable),
							vector(number) option(nullable),vector(number) option(nullable),number option(nullable) );
		
		swap_curve_b2_f_parm(swap_curve_b2_f_parm);
		override swap_curve_type	type() ;
		curve 						basis_crv();
		override string 	ccy();
		override calendar 	cal();
		
	protected:
		curve 			basis_crv_;
		//vector(number)	basis_crv_q_spr_;												
};

swap_curve_type swap_curve_b2_f_parm.type() 		{ return type_;}
curve 			swap_curve_b2_f_parm.basis_crv() 	{ return basis_crv_;}

swap_curve_b2_f_parm.swap_curve_b2_f_parm(	fixing_curve option(nullable) fixing_crv,
											curve option(nullable) 		fra_crv,
											curve 						swap_crv,
											curve 						basis_crv,																					
											curve_blend_parm			crv_blend_parm,											
											vector(number) option(nullable) fra_crv_y_spr,
											vector(number) option(nullable) swap_crv_y_spr,
											vector(number) option(nullable) basis_crv_q_spr,
											vector(number) option(nullable) edfut_cvx_adj) 
											:swap_curve_fwd_f_parm( fixing_crv, fra_crv, swap_crv, crv_blend_parm, swap_curve_type.SCE_FWD_B2_F, 
																	fra_crv_y_spr,swap_crv_y_spr,edfut_cvx_adj,true),											 
											 basis_crv_(basis_crv)/*, basis_crv_q_spr_(clone_vector(basis_crv_q_spr))*/
{
	init_adj(basis_crv_, basis_crv_q_spr, false);
}	

swap_curve_b2_f_parm.swap_curve_b2_f_parm(	curve option(nullable) 		short_crv,
											curve option(nullable) 		fra_crv,
											curve 						swap_crv,
											curve 						basis_crv,																					
											curve_blend_parm			crv_blend_parm,											
											vector(number) option(nullable) fra_crv_y_spr,
											vector(number) option(nullable) swap_crv_y_spr,
											vector(number) option(nullable) basis_crv_q_spr,
											vector(number) option(nullable) edfut_cvx_adj,
											number option(nullable) 	swap_first_fix)
											:swap_curve_fwd_f_parm( short_crv, fra_crv, swap_crv, crv_blend_parm, swap_curve_type.SCE_FWD_B2_F, 
																	fra_crv_y_spr,swap_crv_y_spr,edfut_cvx_adj,swap_first_fix,true),											 
											 basis_crv_(basis_crv)/*, basis_crv_q_spr_(clone_vector(basis_crv_q_spr))*/
{
	init_adj(basis_crv_, basis_crv_q_spr, false);
}

swap_curve_b2_f_parm.swap_curve_b2_f_parm(swap_curve_b2_f_parm s) 
										:swap_curve_fwd_f_parm(s), basis_crv_(s.basis_crv_)/*, basis_crv_q_spr_(clone_vector(s.basis_crv_q_spr_))*/
{}
//-------------------------------------------------------
// ccy
//-------------------------------------------------------
string swap_curve_b2_f_parm.ccy()
{
	string ccy = curve_ext_parm.ccy();
	if(!null(ccy)) 
		return ccy;
		
	if(check_curve(basis_crv_)){		
		return basis_crv_.instruments()[0].currency();					
	}	
	else {
		return null<string>;
	}
}
//-------------------------------------------------------
// cal
//-------------------------------------------------------
calendar swap_curve_b2_f_parm.cal()
{
	calendar cal = curve_ext_parm.cal();
	if(!null(cal)) 
		return cal;
		
	if(check_curve(basis_crv_)){		
		return basis_crv_.instruments()[0].calendar();					
	}	
	else {
		return null<calendar>;
	}
}
//-------------------------------------------------------
// create 
//-------------------------------------------------------
swap_curve_b2_f_parm swap_curve_b2_f_parm(	fixing_curve option(nullable)  fixing_crv,
											curve option(nullable) 		fra_crv,
											curve 						swap_crv,
											curve 						basis_crv,										
											curve_blend_parm			crv_blend_parm, 
											vector(number) option(nullable) fra_crv_y_spr = null<vector(number)>,
											vector(number) option(nullable) swap_crv_y_spr = null<vector(number)>,
											vector(number) option(nullable) basis_crv_q_spr = null<vector(number)>,
											vector(number) option(nullable) edfut_cvx_adj= null<vector(number)>)
										
{					
	return new swap_curve_b2_f_parm(fixing_crv, fra_crv, swap_crv, basis_crv, crv_blend_parm, 
									fra_crv_y_spr, swap_crv_y_spr, basis_crv_q_spr,edfut_cvx_adj);
}
//-------------------------------------------------------
// create 
//-------------------------------------------------------
swap_curve_b2_f_parm swap_curve_b2_f_parm(	curve option(nullable)  	short_crv,
											curve option(nullable) 		fra_crv,
											curve 						swap_crv,
											curve 						basis_crv,										
											curve_blend_parm			crv_blend_parm, 
											vector(number) option(nullable) fra_crv_y_spr = null<vector(number)>,
											vector(number) option(nullable) swap_crv_y_spr = null<vector(number)>,
											vector(number) option(nullable) basis_crv_q_spr = null<vector(number)>,
											vector(number) option(nullable) edfut_cvx_adj= null<vector(number)>,
											number option(nullable) 	swap_first_fix = null<number>) 
										
{					
	return new swap_curve_b2_f_parm(short_crv, fra_crv, swap_crv, basis_crv, crv_blend_parm, 
									fra_crv_y_spr, swap_crv_y_spr, basis_crv_q_spr,edfut_cvx_adj,swap_first_fix);	
}

//-------------------------------------------------------
// create 
//-------------------------------------------------------
/*swap_curve_b2_f_parm swap_curve_b2_f_parm(	swap_curve_b2_f_parm 	parm,
											fixing_curve option(nullable)	fixing_crv) 
							
{
	swap_curve_b2_f_parm p = new swap_curve_b2_f_parm(parm);
	p.set_fixing_crv(fixing_crv);
	return p;
}*/

//-------------------------------------------------------
// create 
//-------------------------------------------------------
/*swap_curve_b2_f_parm swap_curve_b2_f_parm(	swap_curve_b2_f_parm 	parm,
											curve option(nullable)	short_crv) 
							
{
	swap_curve_b2_f_parm p = new swap_curve_b2_f_parm(parm);
	p.set_short_crv(short_crv);
	return p;
}*/