option(null: hard);	

/*	
	Basic swap functions for "dual" bootstrap
	Parameter classes
	Developed by Algorithmica Research, Magnus Nyström
			
	Comments:

	ToDo: 
	
*/


/*-----------------------------------------------------------------------
  Name :    swap_curve_cb1_f_parm
  Notes :           
  Changes:
  			Date    		Who     Detail
  			4-Aug-2016 		MN      
  ----------------------------------------------------------------------*/
class swap_curve_cb1_f_parm : public  swap_curve_ext_parm option (category: 'Yield Curve/003 Curve Building Cross Currency')
{
   	public:
		swap_curve_cb1_f_parm(	fx_spot option(nullable), curve option(nullable), fixing_curve option(nullable),fixing_curve option(nullable),
								curve, logical,logical,integer);			

		//swap_curve_cb1_f_parm(	fx_spot option(nullable), curve option(nullable), curve,curve,
		//						curve, logical,logical,integer);
	
		swap_curve_cb1_f_parm(swap_curve_cb1_f_parm);
		
		override swap_curve_type	type() ;
		day_count_method 			depo_dc_flat();
		day_count_method 			depo_dc_sprd();
		curve 						basis_crv();
		fx_spot						fx_spot();
		fixing_curve				fixing_crv_flat();	
		fixing_curve				fixing_crv_sprd();
		//curve						depo_crv_flat();	
		//curve						depo_crv_sprd();
		logical 					short_is_fix_crv_flat();
		logical 					short_is_fix_crv_sprd();
		void 						set_fixing_crv_flat(fixing_curve option(nullable) );
		void 						set_fixing_crv_sprd(fixing_curve option(nullable) );
		//void 						set_depo_crv_flat(curve option(nullable) );
		//void 						set_depo_crv_sprd(curve option(nullable) );
	protected:
		curve 				basis_crv_;
		fx_spot				fx_spot_;
		fixing_curve		fixing_crv_flat_;	
		fixing_curve		fixing_crv_sprd_;
		//curve				depo_crv_flat_;	
		//curve				depo_crv_sprd_;
};

swap_curve_type swap_curve_cb1_f_parm.type() 			{ return type_;}
curve 			swap_curve_cb1_f_parm.basis_crv() 		{ return basis_crv_;}
fx_spot			swap_curve_cb1_f_parm.fx_spot()			{ return fx_spot_;}
fixing_curve	swap_curve_cb1_f_parm.fixing_crv_flat()	{ return fixing_crv_flat_;}	
fixing_curve	swap_curve_cb1_f_parm.fixing_crv_sprd()	{ return fixing_crv_sprd_;}	
//day_count_method swap_curve_cb1_f_parm.depo_dc_flat() 	{ return null(fixing_crv_flat_) ? depo_crv_flat_.instruments()[0].dc_method(): fixing_crv_flat_.instruments()[0].dc_method();}
//day_count_method swap_curve_cb1_f_parm.depo_dc_sprd() 	{ return null(fixing_crv_sprd_) ? depo_crv_sprd_.instruments()[0].dc_method() : fixing_crv_sprd_.instruments()[0].dc_method();}
day_count_method swap_curve_cb1_f_parm.depo_dc_flat() 	{ return short_is_fix_crv_flat() ? fixing_crv_flat_.instruments()[0].dc_method() : null<day_count_method>;}
day_count_method swap_curve_cb1_f_parm.depo_dc_sprd() 	{ return short_is_fix_crv_sprd() ? fixing_crv_sprd_.instruments()[0].dc_method() : null<day_count_method>;}

//curve	swap_curve_cb1_f_parm.depo_crv_flat()			{ return depo_crv_flat_;}	
//curve	swap_curve_cb1_f_parm.depo_crv_sprd()			{ return depo_crv_sprd_;}
logical swap_curve_cb1_f_parm.short_is_fix_crv_flat()	{ return !null(fixing_crv_flat_);}
logical swap_curve_cb1_f_parm.short_is_fix_crv_sprd()	{ return !null(fixing_crv_sprd_);}

swap_curve_cb1_f_parm.swap_curve_cb1_f_parm(..fx_spot option(nullable)	fx_sp,
											curve option(nullable) 		fxswap_crv,			
											fixing_curve option(nullable) fixing_crv_flat,
											fixing_curve option(nullable) fixing_crv_sprd,								
											curve 						basis_crv,																																	
											logical						merge_crv,
											logical						prio_fxswap,											
											integer						blend_buf_days) 
											:swap_curve_ext_parm(	fxswap_crv, null<curve>, null<curve>, null<number>, false, false,
																	merge_crv, (prio_fxswap? curve_prio.SHORT : curve_prio.LONG),
																	(prio_fxswap? curve_prio.LONG : curve_prio.SHORT),
																	blend_buf_days, swap_curve_type.SCE_CURR_B1_F, null<vector(number)>,true),
											 basis_crv_(basis_crv), fx_spot_(fx_sp) ,fixing_crv_flat_(fixing_crv_flat),
											 fixing_crv_sprd_(fixing_crv_sprd) /*,depo_crv_flat_(null<curve>),
											 depo_crv_sprd_(null<curve>)*/										 
{}	

/*swap_curve_cb1_f_parm.swap_curve_cb1_f_parm(..fx_spot option(nullable)	fx_sp,
											curve option(nullable) 		fxswap_crv,			
											curve  						depo_crv_flat,
											curve  						depo_crv_sprd,								
											curve 						basis_crv,																																	
											logical						merge_crv,
											logical						prio_fxswap,											
											integer						blend_buf_days) 
											:swap_curve_ext_parm(	fxswap_crv, null<curve>, null<curve>, null<number>, false, false,
																	merge_crv, (prio_fxswap? curve_prio.SHORT : curve_prio.LONG),
																	(prio_fxswap? curve_prio.LONG : curve_prio.SHORT),
																	blend_buf_days, SCE_CURR_B1_F, null<vector(number)>,true),
											 basis_crv_(basis_crv), fx_spot_(fx_sp) ,fixing_crv_flat_(null<fixing_curve>),
											 fixing_crv_sprd_(null<fixing_curve>) ,depo_crv_flat_(depo_crv_flat),
											 depo_crv_sprd_(depo_crv_sprd)											 
{}*/

swap_curve_cb1_f_parm.swap_curve_cb1_f_parm(swap_curve_cb1_f_parm s) 
										:swap_curve_ext_parm(s), basis_crv_(s.basis_crv_),fx_spot_(s.fx_spot_),
										 fixing_crv_flat_(s.fixing_crv_flat_), fixing_crv_sprd_(s.fixing_crv_sprd_) /*,
										 depo_crv_flat_(s.depo_crv_flat_), depo_crv_sprd_(s.depo_crv_sprd_)*/	
{}

//-------------------------------------------------------
// set_fixing_crv_flat
//-------------------------------------------------------
void swap_curve_cb1_f_parm.set_fixing_crv_flat(fixing_curve option(nullable) f)
{
	fixing_crv_flat_ 	= f;
	//depo_crv_flat_		= null<curve>;
}

//-------------------------------------------------------
// set_depo_crv_flat
//-------------------------------------------------------
/*void swap_curve_cb1_f_parm.set_depo_crv_flat(curve option(nullable) s)
{
	fixing_crv_flat_ 	= null<fixing_curve>;
	depo_crv_flat_		= s;
}*/
//-------------------------------------------------------
// set_fixing_crv_sprd
//-------------------------------------------------------
void swap_curve_cb1_f_parm.set_fixing_crv_sprd(fixing_curve option(nullable) f)
{
	fixing_crv_sprd_ 	= f;
	//depo_crv_sprd_		= null<curve>;
}

//-------------------------------------------------------
// set_depo_crv_sprd
//-------------------------------------------------------
/*void swap_curve_cb1_f_parm.set_depo_crv_sprd(curve option(nullable) s)
{
	fixing_crv_sprd_ 	= null<fixing_curve>;
	depo_crv_sprd_		= s;
}*/
//-------------------------------------------------------
// create swap_curve_cb1_f_parm
//-------------------------------------------------------
swap_curve_cb1_f_parm swap_curve_cb1_f_parm(fx_spot option(nullable)	fx_sp,
											curve option(nullable) 		fxswap_crv,
											fixing_curve option(nullable) fixing_crv_flat,
											fixing_curve option(nullable) fixing_crv_sprd,											
											curve 						basis_crv,																																	
											logical						merge_crv,
											logical						prio_fxswap,											
											integer						blend_buf_days) 
										
{					
	return new swap_curve_cb1_f_parm(	fx_sp, fxswap_crv,  fixing_crv_flat, fixing_crv_sprd,basis_crv, 
										merge_crv, prio_fxswap, blend_buf_days);	
}
//-------------------------------------------------------
// create swap_curve_cb1_f_parm
//-------------------------------------------------------
/*swap_curve_cb1_f_parm swap_curve_cb1_f_parm(fx_spot option(nullable)	fx_sp,
											curve option(nullable) 		fxswap_crv,
											curve  						depo_crv_flat,
											curve  						depo_crv_sprd,											
											curve 						basis_crv,																																	
											logical						merge_crv,
											logical						prio_fxswap,											
											integer						blend_buf_days) 
										
{					
	return new swap_curve_cb1_f_parm(	fx_sp, fxswap_crv,  depo_crv_flat, depo_crv_sprd,basis_crv, 
										merge_crv, prio_fxswap, blend_buf_days);	
}*/
//-------------------------------------------------------
// create swap_curve_cb1_f_parm
//-------------------------------------------------------
/*swap_curve_cb1_f_parm swap_curve_cb1_f_parm(swap_curve_cb1_f_parm 		parm,
											fixing_curve  				fixing_crv_flat,
											fixing_curve  				fixing_crv_sprd ) 
										
{					
	return new swap_curve_cb1_f_parm(	parm.fx_spot(), parm.short_crv(),  fixing_crv_flat, fixing_crv_sprd, parm.basis_crv(), 
										parm.merge_crv(), parm.prio1() == curve_prio.SHORT, parm.blend_buf_days());	
}*/


/*-----------------------------------------------------------------------
  Name :    swap_curve_cbois1_f_parm
  Notes :           
  Changes:
  			Date    		Who     Detail
  			4-Aug-2016 		MN      
  ----------------------------------------------------------------------*/
class swap_curve_cbois1_f_parm : public  swap_curve_ext_parm option (category: 'Yield Curve/003 Curve Building Cross Currency')
{
   	public:			

		swap_curve_cbois1_f_parm(fx_spot option(nullable), curve option(nullable), fixing_curve option(nullable),
								curve, logical,logical,integer);
	
		swap_curve_cbois1_f_parm(swap_curve_cbois1_f_parm);
		
		override swap_curve_type	type() ;
		curve 						basis_crv();
		fx_spot						fx_spot();
		fixing_curve				fixing_crv();	
		day_count_method 			depo_dc() ;
		logical						short_is_fix_crv();
		void 						set_fixing_crv(fixing_curve option(nullable) );
	protected:			
		curve 				basis_crv_;
		fx_spot				fx_spot_;
		fixing_curve		fixing_crv_;
};

swap_curve_type swap_curve_cbois1_f_parm.type() 			{ return type_;}
curve 			swap_curve_cbois1_f_parm.basis_crv() 		{ return basis_crv_;}
fx_spot			swap_curve_cbois1_f_parm.fx_spot()			{ return fx_spot_;}	
fixing_curve	swap_curve_cbois1_f_parm.fixing_crv()		{ return fixing_crv_;}	
day_count_method swap_curve_cbois1_f_parm.depo_dc() 		{ return short_is_fix_crv() ? fixing_crv_.instruments()[0].dc_method() : null<day_count_method>;}
logical 		swap_curve_cbois1_f_parm.short_is_fix_crv()	{ return !null(fixing_crv_);}	

swap_curve_cbois1_f_parm.swap_curve_cbois1_f_parm(..fx_spot option(nullable)	fx_sp,
											curve option(nullable) 		fxswap_crv,
											fixing_curve option(nullable) fixing_crv,//for flt-leg only i.e. only used if basis swap is a flt vs ois
											curve 						basis_crv,																																	
											logical						merge_crv,
											logical						prio_fxswap,											
											integer						blend_buf_days) 
											:swap_curve_ext_parm(	fxswap_crv, null<curve>, null<curve>, null<number>, false, false,
																	merge_crv, (prio_fxswap? curve_prio.SHORT : curve_prio.LONG),
																	(prio_fxswap? curve_prio.LONG : curve_prio.SHORT),
																	blend_buf_days, swap_curve_type.SCE_CURR_B1_O, null<vector(number)>,false),
											 basis_crv_(basis_crv), fx_spot_(fx_sp), fixing_crv_(fixing_crv)										 
{}

swap_curve_cbois1_f_parm.swap_curve_cbois1_f_parm(swap_curve_cbois1_f_parm s) 
										:swap_curve_ext_parm(s), basis_crv_(s.basis_crv_),fx_spot_(s.fx_spot_),fixing_crv_(s.fixing_crv_)
{}

//-------------------------------------------------------
// set_fixing_crv
//-------------------------------------------------------
void swap_curve_cbois1_f_parm.set_fixing_crv(fixing_curve option(nullable) f)
{
	fixing_crv_ 	= f;
	//depo_crv_flat_		= null<curve>;
}

//-------------------------------------------------------
// create swap_curve_cbois1_f_parm
//-------------------------------------------------------
swap_curve_cbois1_f_parm swap_curve_cbois1_f_parm(fx_spot option(nullable)	fx_sp,
											curve option(nullable) 		fxswap_crv,
											fixing_curve option(nullable) fixing_crv,//for flt-leg only i.e. only used if basis swap is a flt vs ois											
											curve 						basis_crv,																																	
											logical						merge_crv,
											logical						prio_fxswap,											
											integer						blend_buf_days) 
										
{					
	return new swap_curve_cbois1_f_parm(fx_sp, fxswap_crv,fixing_crv,basis_crv, 
										merge_crv, prio_fxswap, blend_buf_days);	
}