option(null: hard);	

/*	
	Basic swap functions for "dual" bootstrap
	Parameter classes
	Developed by Algorithmica Research, Magnus Nyström
			
	Comments:

	ToDo: 
	
*/


/*-----------------------------------------------------------------------
  Name :    swap_curve_cff_f_parm
  Notes :           
  Changes:
  			Date    		Who     Detail
  			9-Aug-2016 		MN      
  ----------------------------------------------------------------------*/
class swap_curve_cff_f_parm : public  swap_curve_ext_parm option (category: 'Yield Curve/003 Curve Building Cross Currency')
{
   	public:
		swap_curve_cff_f_parm(fx_spot option(nullable), curve option(nullable), fixing_curve option(nullable), curve, logical,logical,integer);			
		swap_curve_cff_f_parm(swap_curve_cff_f_parm);
		
		override swap_curve_type	type() ;
		fx_spot						fx_spot();
		fixing_curve				fixing_crv();	
		curve						fixflt_crv();
		void 						set_fixing_crv(fixing_curve option(nullable) );
	protected:
		curve 				fixflt_crv_;
		fixing_curve		fixing_crv_;
		fx_spot				fx_spot_;
													
};

swap_curve_type swap_curve_cff_f_parm.type() 		{ return type_;}
fx_spot			swap_curve_cff_f_parm.fx_spot()		{ return fx_spot_;}
fixing_curve	swap_curve_cff_f_parm.fixing_crv()	{ return fixing_crv_;}	
curve			swap_curve_cff_f_parm.fixflt_crv()	{ return fixflt_crv_;}	

swap_curve_cff_f_parm.swap_curve_cff_f_parm(..fx_spot option(nullable)	fx_sp,
											curve option(nullable) 		fxswap_crv,	
											fixing_curve  option(nullable) fixing_crv,																					
											curve 						fixflt_crv,																					
											logical						merge_crv,
											logical						prio_fxswap,											
											integer						blend_buf_days) 
											:swap_curve_ext_parm(	fxswap_crv, null<curve>, null<curve>, null<number>, false, false,
																	merge_crv, (prio_fxswap? curve_prio.SHORT : curve_prio.LONG),
																	(prio_fxswap? curve_prio.LONG : curve_prio.SHORT),
																	blend_buf_days, swap_curve_type.SCE_CURR_FF_F, null<vector(number)>,false),
											 fixflt_crv_(fixflt_crv), fixing_crv_(fixing_crv),fx_spot_(fx_sp) 
{}	


swap_curve_cff_f_parm.swap_curve_cff_f_parm(swap_curve_cff_f_parm s) 
										:swap_curve_ext_parm(s), fixflt_crv_(s.fixflt_crv_), fx_spot_(s.fx_spot_)
{}

//-------------------------------------------------------
// set_fixing_crv
//-------------------------------------------------------
void swap_curve_cff_f_parm.set_fixing_crv(fixing_curve option(nullable) f)
{
	//swap_curve_ext_parm.set_short_crv(null(f) ? null<curve>: f.inst_curve());
	fixing_crv_ 		= f;
	//short_is_fix_crv_ 	= !null(f);
}

//-------------------------------------------------------
// create swap_curve_cff_f_parm
//-------------------------------------------------------
swap_curve_cff_f_parm swap_curve_cff_f_parm(fx_spot option(nullable)	fx_sp,
											curve option(nullable) 		fxswap_crv,
											fixing_curve option(nullable) fixing_crv,											
											curve 						fixflt_crv,																				
											logical						merge_crv,
											logical						prio_fxswap,											
											integer						blend_buf_days) 
										
{					
	return new swap_curve_cff_f_parm(fx_sp, fxswap_crv,  fixing_crv, fixflt_crv, merge_crv, prio_fxswap, blend_buf_days);	
}
//-------------------------------------------------------
// create swap_curve_cff_f_parm
//-------------------------------------------------------
/*swap_curve_cff_f_parm swap_curve_cff_f_parm(swap_curve_cff_f_parm		parm,											
											fixing_curve  				fixing_crv) 
										
{					
	return new swap_curve_cff_f_parm(parm.fx_spot(), parm.short_crv(),  fixing_crv, parm.fixflt_crv(), parm.merge_crv(), 
									parm.prio1() == curve_prio.SHORT, parm.blend_buf_days());	
}*/