option(null: hard);	

/*	
	Basic swap functions for "dual" bootstrap
	Parameter classes
	Developed by Algorithmica Research, Magnus Nyström
			
	Comments:

	ToDo: 
	
*/

/*-----------------------------------------------------------------------
  Name :    class swap_curve_disc_parm
  Notes :           
  Changes:
  			Date    		Who     Detail
  			? 				MN      Original code (moved from fiws) 
  ----------------------------------------------------------------------*/
class swap_curve_disc_parm : public  swap_curve_ext_parm option (category: 'Yield Curve/003 Curve Building')
{
   	public:
	
		swap_curve_disc_parm(curve option(nullable), curve option(nullable), curve option(nullable), 
							logical,logical,logical,curve_prio,curve_prio,integer,vector(number) option(nullable));			

		swap_curve_disc_parm(curve option(nullable), curve option(nullable), curve option(nullable), 
							curve_blend_parm,vector(number) option(nullable),
							vector(number) option(nullable),vector(number) option(nullable),vector(number) option(nullable) );
		
	protected:
		swap_curve_disc_parm(curve option(nullable), curve option(nullable), curve option(nullable), 
							curve_blend_parm,swap_curve_type,vector(number) option(nullable),
							vector(number) option(nullable),vector(number) option(nullable),vector(number) option(nullable),logical);

	
		swap_curve_disc_parm(	swap_curve_disc_parm);	
		override swap_curve_type type();										
};

swap_curve_type swap_curve_disc_parm.type() {return type_;}

swap_curve_disc_parm.swap_curve_disc_parm(	curve option(nullable) 		short_crv,
											curve option(nullable) 		fra_crv,
											curve option(nullable)		swap_crv,
											logical						no_overlap_fwd,
											logical						merge_fra,
											logical						merge_crv,
											curve_prio					prio1,
											curve_prio					prio2,
											integer						blend_buf_days,
											vector(number) option(nullable) edfut_cvx_adj) 
											:swap_curve_ext_parm(	short_crv, fra_crv, swap_crv, null<number>, no_overlap_fwd, merge_fra,
																	merge_crv, prio1, prio2, blend_buf_days, swap_curve_type.SCE_DISC, edfut_cvx_adj,true) 
{}	

swap_curve_disc_parm.swap_curve_disc_parm(	curve option(nullable) 		short_crv,
											curve option(nullable) 		fra_crv,
											curve option(nullable)		swap_crv,
											curve_blend_parm			crv_blend_parm,
											vector(number) option(nullable) short_crv_y_spr,
											vector(number) option(nullable) fra_crv_y_spr,
											vector(number) option(nullable) swap_crv_y_spr,
											vector(number) option(nullable) edfut_cvx_adj) 
											:swap_curve_ext_parm(	short_crv, fra_crv, swap_crv, null<number>, crv_blend_parm.no_overlap_fwd_, 
																	crv_blend_parm.merge_middle_,crv_blend_parm.merge_crv_, crv_blend_parm.prio1_, 
																	crv_blend_parm.prio2_, crv_blend_parm.blend_buf_days_, swap_curve_type.SCE_DISC, short_crv_y_spr,
																	fra_crv_y_spr, swap_crv_y_spr,edfut_cvx_adj,true) 
{}
//-------------------------------------------------------
// constructor  prot.
//-------------------------------------------------------
swap_curve_disc_parm.swap_curve_disc_parm(	curve option(nullable) 		short_crv,
											curve option(nullable) 		fra_crv,
											curve option(nullable)		swap_crv,
											curve_blend_parm			crv_blend_parm,
											swap_curve_type				type,
											vector(number) option(nullable) short_crv_y_spr,
											vector(number) option(nullable) fra_crv_y_spr,
											vector(number) option(nullable) swap_crv_y_spr,
											vector(number) option(nullable) edfut_cvx_adj,
											logical 					run_prio)
											:swap_curve_ext_parm(	short_crv, fra_crv, swap_crv, null<number>, crv_blend_parm.no_overlap_fwd_, 
																	crv_blend_parm.merge_middle_,crv_blend_parm.merge_crv_, crv_blend_parm.prio1_, 
																	crv_blend_parm.prio2_, crv_blend_parm.blend_buf_days_, type, short_crv_y_spr,
																	fra_crv_y_spr, swap_crv_y_spr,edfut_cvx_adj,run_prio) 
{}

swap_curve_disc_parm.swap_curve_disc_parm(swap_curve_disc_parm s) :swap_curve_ext_parm(s)
{}

//-------------------------------------------------------
// create swap_curve_disc_parm
//-------------------------------------------------------
swap_curve_disc_parm swap_curve_disc_parm(	curve option(nullable) 		short_crv,
											curve option(nullable) 		fra_crv,
											curve option(nullable)		swap_crv,
											logical						no_overlap_fwd,
											logical						merge_fra,
											logical						merge_crv,
											curve_prio					prio1,
											curve_prio					prio2,
											integer						blend_buf_days,
											vector(number) option(nullable) edfut_cvx_adj = null<vector(number)>) 
										
{					
	return new swap_curve_disc_parm(short_crv, fra_crv, swap_crv,  no_overlap_fwd, merge_fra,
									merge_crv, prio1, prio2, blend_buf_days, edfut_cvx_adj);	
}
//-------------------------------------------------------
// create swap_curve_disc_parm
//-------------------------------------------------------
swap_curve_disc_parm swap_curve_disc_parm(	curve option(nullable) 		short_crv,
											curve option(nullable) 		fra_crv,
											curve option(nullable)		swap_crv,
											curve_blend_parm			crv_blend_parm,
											vector(number) option(nullable) short_crv_y_spr = null<vector(number)>,
											vector(number) option(nullable) fra_crv_y_spr = null<vector(number)>,
											vector(number) option(nullable) swap_crv_y_spr = null<vector(number)>,
											vector(number) option(nullable) edfut_cvx_adj = null<vector(number)>) 
										
{					
	return new swap_curve_disc_parm(	short_crv, fra_crv, swap_crv,  crv_blend_parm,  
										short_crv_y_spr, fra_crv_y_spr, swap_crv_y_spr,edfut_cvx_adj);	
}