option(null: hard);	

/*	
	Basic swap functions for "dual" bootstrap
	Parameter classes
	Developed by Algorithmica Research, Magnus Nyström
			
	Comments:

	ToDo: 
	
*/


/*-----------------------------------------------------------------------
  Name :    swap_curve_b1_disc_parm
  Notes :           
  Changes:
  			Date    		Who     Detail
  			4-Aug-2016 		MN      
  ----------------------------------------------------------------------*/
class swap_curve_b1_disc_parm : public  swap_curve_disc_parm option (category: 'Yield Curve/003 Curve Building')
{   	
	public:
	
		swap_curve_b1_disc_parm(curve option(nullable), curve option(nullable), curve option(nullable), 
								curve option(nullable)	, curve ,  curve_blend_parm,
								vector(number) option(nullable), vector(number) option(nullable),
								vector(number) option(nullable),vector(number) option(nullable),
								vector(number) option(nullable),vector(number) option(nullable) );			
	
		swap_curve_b1_disc_parm(swap_curve_b1_disc_parm);
		override string 			ccy();
		override calendar 			cal();
		override swap_curve_type	type();
		curve 						lib_swap_crv();	
		curve 						ois_lib_basis_crv();
	protected:
		curve 			lib_swap_crv_;	
		curve 			ois_lib_basis_crv_;												
};

swap_curve_type swap_curve_b1_disc_parm.type() 				{ return type_;}
curve 			swap_curve_b1_disc_parm.lib_swap_crv()		{ return lib_swap_crv_;}	
curve 			swap_curve_b1_disc_parm.ois_lib_basis_crv()	{ return ois_lib_basis_crv_;}

		
swap_curve_b1_disc_parm.swap_curve_b1_disc_parm(curve option(nullable) 		short_crv,
												curve option(nullable) 		middle_crv,
												curve option(nullable)		long_crv,
												curve option(nullable)		lib_swap_crv,//not necessary when swap curve is taken from swap_curve_fwd_f_parm
												curve 						ois_lib_basis_crv,	
												curve_blend_parm			crv_blend_parm,	
												vector(number) option(nullable) short_crv_y_spr ,
												vector(number) option(nullable) middle_crv_y_spr ,
												vector(number) option(nullable) long_crv_y_spr ,
												vector(number) option(nullable) lib_swap_crv_y_spr ,
												vector(number) option(nullable) ois_lib_basis_crv_q_spr ,
												vector(number) option(nullable) edfut_cvx_adj) 
												:swap_curve_disc_parm(	short_crv, middle_crv, long_crv, crv_blend_parm, 
																		swap_curve_type.SCE_DISC_B1, short_crv_y_spr, middle_crv_y_spr, long_crv_y_spr,edfut_cvx_adj,true),
										 		lib_swap_crv_(lib_swap_crv), ois_lib_basis_crv_(ois_lib_basis_crv) 
{
	init_adj(lib_swap_crv_, lib_swap_crv_y_spr, true);
	init_adj(ois_lib_basis_crv_, ois_lib_basis_crv_q_spr, false);
}	

swap_curve_b1_disc_parm.swap_curve_b1_disc_parm(swap_curve_b1_disc_parm s) 
										:swap_curve_disc_parm(s), lib_swap_crv_(s.lib_swap_crv_),
										 ois_lib_basis_crv_(s.ois_lib_basis_crv_)/*, basis_crv_q_spr_(clone_vector(s.basis_crv_q_spr_))*/
{}

//-------------------------------------------------------
// create 
//-------------------------------------------------------
swap_curve_b1_disc_parm swap_curve_b1_disc_parm(curve option(nullable) 		short_crv,
												curve option(nullable) 		middle_crv,
												curve option(nullable)		long_crv,												
												curve option(nullable)		lib_swap_crv,//not necessary when swap curve is taken from swap_curve_fwd_f_parm
												curve 						ois_lib_basis_crv,	
												curve_blend_parm			crv_blend_parm,													
												vector(number) option(nullable) short_crv_y_spr = null<vector(number)>,
												vector(number) option(nullable) middle_crv_y_spr = null<vector(number)>,
												vector(number) option(nullable) long_crv_y_spr = null<vector(number)>,
												vector(number) option(nullable) lib_swap_crv_y_spr = null<vector(number)>,
												vector(number) option(nullable) ois_lib_basis_crv_q_spr = null<vector(number)>,
												vector(number) option(nullable) edfut_cvx_adj = null<vector(number)>)
										
{					
	return new swap_curve_b1_disc_parm(short_crv, middle_crv, long_crv, lib_swap_crv, ois_lib_basis_crv,   
										crv_blend_parm, short_crv_y_spr,middle_crv_y_spr,  
										long_crv_y_spr, lib_swap_crv_y_spr, ois_lib_basis_crv_q_spr,edfut_cvx_adj);	
}

//-------------------------------------------------------
// ccy
//-------------------------------------------------------
string swap_curve_b1_disc_parm.ccy()
{
	string ccy = curve_ext_parm.ccy();
	if(!null(ccy))
		return ccy;
		
	if(check_curve(lib_swap_crv())){		
		return lib_swap_crv().instruments()[0].currency();					
	}
	else if(check_curve(ois_lib_basis_crv())){
		return  ois_lib_basis_crv().instruments()[0].currency();						
	}
	else {
		return null<string>;
	}
}
//-------------------------------------------------------
// cal
//-------------------------------------------------------
calendar swap_curve_b1_disc_parm.cal()
{
	calendar c = curve_ext_parm.cal();
	if(!null(c))
		return c;
		
	if(check_curve(lib_swap_crv())){		
		return lib_swap_crv().instruments()[0].calendar();					
	}
	else if(check_curve(ois_lib_basis_crv())){
		return  ois_lib_basis_crv().instruments()[0].calendar();						
	}
	else {
		return null<calendar>;
	}
}