option(null: hard);	

/*	
	Basic swap functions for "dual" bootstrap
	Parameter classes
	Developed by Algorithmica Research, Magnus Nyström
			
	Comments:

	ToDo: 
	
*/


/*-----------------------------------------------------------------------
  Name :    class swap_curve_fwd_f_parm
  Notes :           
  Changes:
  			Date    		Who     Detail
  			2-Aug-2016 		MN      
  ----------------------------------------------------------------------*/
class swap_curve_fwd_f_parm : public  swap_curve_ext_parm option (category: 'Yield Curve/003 Curve Building')
{
   	public:				

		swap_curve_fwd_f_parm(	fixing_curve option(nullable), curve option(nullable), curve option(nullable), 
								curve_blend_parm,vector(number) option(nullable),vector(number) option(nullable),
								vector(number) option(nullable)  );

		swap_curve_fwd_f_parm(	curve option(nullable), curve option(nullable), curve option(nullable), 
								curve_blend_parm,vector(number) option(nullable),vector(number) option(nullable),
								vector(number) option(nullable) ,number option(nullable));

		swap_curve_fwd_f_parm(swap_curve_fwd_f_parm);

		virtual swap_curve_type type() ;
		fixing_curve	fixing_crv();
		void 			set_fixing_crv(fixing_curve option(nullable));
		override void 	set_short_crv(curve option(nullable));
		logical 		short_is_fix_crv();
		
	protected:
		swap_curve_fwd_f_parm(	fixing_curve option(nullable), curve option(nullable), curve option(nullable), 
								curve_blend_parm, swap_curve_type,vector(number) option(nullable),
								vector(number) option(nullable),
								vector(number) option(nullable) , logical);
		
		swap_curve_fwd_f_parm(	curve option(nullable), curve option(nullable), curve option(nullable), 
								curve_blend_parm, swap_curve_type,vector(number) option(nullable),
								vector(number) option(nullable),
								vector(number) option(nullable), number option(nullable), logical);
		
		logical short_is_fix_crv_;	
		fixing_curve	fixing_crv_;
};

swap_curve_type swap_curve_fwd_f_parm.type() 				{ return type_;}
fixing_curve	swap_curve_fwd_f_parm.fixing_crv() 			{ return fixing_crv_;}
logical 		swap_curve_fwd_f_parm.short_is_fix_crv()	{ return short_is_fix_crv_;}

//-------------------------------------------------------
// set_fixing_crv
//-------------------------------------------------------
void swap_curve_fwd_f_parm.set_fixing_crv(fixing_curve option(nullable) f)
{
	swap_curve_ext_parm.set_short_crv(null(f) ? null<curve>: f.inst_curve());
	fixing_crv_ 		= f;
	short_is_fix_crv_ 	= !null(f);
}

//-------------------------------------------------------
// set_short_crv
//-------------------------------------------------------
void swap_curve_fwd_f_parm.set_short_crv(curve option(nullable) s)
{
	swap_curve_ext_parm.set_short_crv(s);
	fixing_crv_ 		= null<fixing_curve>;
	short_is_fix_crv_ 	= false;
}

//-------------------------------------------------------
// constructor (fixing curve)
//-------------------------------------------------------
swap_curve_fwd_f_parm.swap_curve_fwd_f_parm(fixing_curve option(nullable)	fixing_crv,
											curve option(nullable) 		fra_crv,
											curve option(nullable)		swap_crv,											
											curve_blend_parm			crv_blend_parm,																						
											vector(number) option(nullable) fra_crv_y_spr,
											vector(number) option(nullable) swap_crv_y_spr,
											vector(number) option(nullable) edfut_cvx_adj) 
											:swap_curve_ext_parm(	null(fixing_crv) ? null<curve>: fixing_crv.inst_curve(), fra_crv, swap_crv, null<number>,
																	crv_blend_parm.no_overlap_fwd_,
																	crv_blend_parm.merge_middle_,crv_blend_parm.merge_crv_, crv_blend_parm.prio1_, 
																	crv_blend_parm.prio2_, crv_blend_parm.blend_buf_days_, swap_curve_type.SCE_FWD_F, null<vector(number)>,
																	fra_crv_y_spr, swap_crv_y_spr,edfut_cvx_adj,true),
											 short_is_fix_crv_(true),fixing_crv_(fixing_crv) 
{}
//-------------------------------------------------------
// constructor (fixing curve)  -protected
//-------------------------------------------------------
swap_curve_fwd_f_parm.swap_curve_fwd_f_parm(fixing_curve option(nullable)	fixing_crv,
											curve option(nullable) 		fra_crv,
											curve option(nullable)		swap_crv,											
											curve_blend_parm			crv_blend_parm,
											swap_curve_type				type,																						
											vector(number) option(nullable) fra_crv_y_spr,
											vector(number) option(nullable) swap_crv_y_spr,
											vector(number) option(nullable) edfut_cvx_adj,
											logical 					run_prio)
											:swap_curve_ext_parm(	null(fixing_crv) ? null<curve>: fixing_crv.inst_curve(), fra_crv, swap_crv, null<number>,
																	crv_blend_parm.no_overlap_fwd_,
																	crv_blend_parm.merge_middle_,crv_blend_parm.merge_crv_, crv_blend_parm.prio1_, 
																	crv_blend_parm.prio2_, crv_blend_parm.blend_buf_days_, type, null<vector(number)>,
																	fra_crv_y_spr, swap_crv_y_spr,edfut_cvx_adj, run_prio),
											 short_is_fix_crv_(true),fixing_crv_(fixing_crv) 
{}
//-------------------------------------------------------
// constructor (depo)
//-------------------------------------------------------
swap_curve_fwd_f_parm.swap_curve_fwd_f_parm(curve option(nullable)		depo_crv,
											curve option(nullable) 		fra_crv,
											curve option(nullable)		swap_crv,											
											curve_blend_parm			crv_blend_parm,																						
											vector(number) option(nullable) fra_crv_y_spr,
											vector(number) option(nullable) swap_crv_y_spr,
											vector(number) option(nullable) edfut_cvx_adj,
											number option(nullable) 	swap_first_fix)
											:swap_curve_ext_parm(	depo_crv, fra_crv, swap_crv, swap_first_fix, crv_blend_parm.no_overlap_fwd_, 
																	crv_blend_parm.merge_middle_,crv_blend_parm.merge_crv_, crv_blend_parm.prio1_, 
																	crv_blend_parm.prio2_, crv_blend_parm.blend_buf_days_, swap_curve_type.SCE_FWD_F, null<vector(number)>,
																	fra_crv_y_spr, swap_crv_y_spr,edfut_cvx_adj,true),
											 short_is_fix_crv_(false),fixing_crv_(null<fixing_curve>) 
{

	if(!null(depo_crv)){
		vector(instrument) vi = depo_crv.instruments();
		if(v_size(vi) > 0 && vi[0].instr_type() == instr_type.DEPOSIT_INDEX) {			
				fixing_crv_			= fixing_curve(depo_crv);				
				short_is_fix_crv_ 	= !null(fixing_crv_);
		}
	}
}
//-------------------------------------------------------
// constructor (depo)  -protected
//-------------------------------------------------------
swap_curve_fwd_f_parm.swap_curve_fwd_f_parm(curve option(nullable)		depo_crv,
											curve option(nullable) 		fra_crv,
											curve option(nullable)		swap_crv,											
											curve_blend_parm			crv_blend_parm,
											swap_curve_type				type,																						
											vector(number) option(nullable) fra_crv_y_spr,
											vector(number) option(nullable) swap_crv_y_spr,
											vector(number) option(nullable) edfut_cvx_adj,
											number option(nullable) 	swap_first_fix,
											logical 					run_prio) 
											:swap_curve_ext_parm(	depo_crv, fra_crv, swap_crv, swap_first_fix, crv_blend_parm.no_overlap_fwd_, 
																	crv_blend_parm.merge_middle_,crv_blend_parm.merge_crv_, crv_blend_parm.prio1_, 
																	crv_blend_parm.prio2_, crv_blend_parm.blend_buf_days_, type, null<vector(number)>,
																	fra_crv_y_spr, swap_crv_y_spr,edfut_cvx_adj,run_prio),
											 short_is_fix_crv_(false),fixing_crv_(null<fixing_curve>) 
{
	if(!null(depo_crv)){
		vector(instrument) vi = depo_crv.instruments();
		if(v_size(vi) > 0 && vi[0].instr_type() == instr_type.DEPOSIT_INDEX) {			
				fixing_crv_			= fixing_curve(depo_crv);				
				short_is_fix_crv_ 	= !null(fixing_crv_);
		}
	}
}
//-------------------------------------------------------
// copy constructor 
//-------------------------------------------------------
swap_curve_fwd_f_parm.swap_curve_fwd_f_parm(swap_curve_fwd_f_parm s) :swap_curve_ext_parm(s),
																	  short_is_fix_crv_(s.short_is_fix_crv_),fixing_crv_(s.fixing_crv_)
{}

//-------------------------------------------------------
// create 
//-------------------------------------------------------
swap_curve_fwd_f_parm swap_curve_fwd_f_parm(fixing_curve option(nullable) fixing_crv,
											curve option(nullable) 		fra_crv,
											curve option(nullable)		swap_crv,										
											curve_blend_parm			crv_blend_parm,																						
											vector(number) option(nullable) fra_crv_y_spr = null<vector(number)>,
											vector(number) option(nullable) swap_crv_y_spr = null<vector(number)>,
											vector(number) option(nullable) edfut_cvx_adj= null<vector(number)>) 
							
{					
	return new swap_curve_fwd_f_parm(fixing_crv, fra_crv, swap_crv, crv_blend_parm,
									fra_crv_y_spr,swap_crv_y_spr,edfut_cvx_adj);
}

//-------------------------------------------------------
// create 
//-------------------------------------------------------
swap_curve_fwd_f_parm swap_curve_fwd_f_parm(curve option(nullable) 		depo_crv,
											curve option(nullable) 		fra_crv,
											curve option(nullable)		swap_crv,										
											curve_blend_parm			crv_blend_parm,																						
											vector(number) option(nullable) fra_crv_y_spr = null<vector(number)>,
											vector(number) option(nullable) swap_crv_y_spr = null<vector(number)>,
											vector(number) option(nullable) edfut_cvx_adj= null<vector(number)>,
											number option(nullable) 	swap_first_fix = null<number>) 
							
{					
	return  new swap_curve_fwd_f_parm(depo_crv, fra_crv, swap_crv, crv_blend_parm,
										fra_crv_y_spr,swap_crv_y_spr,edfut_cvx_adj,swap_first_fix);
}


//-------------------------------------------------------
// create 
//-------------------------------------------------------
/*swap_curve_fwd_f_parm swap_curve_fwd_f_parm(swap_curve_fwd_f_parm 	parm,
											fixing_curve option(nullable)	fixing_crv) 
							
{
	swap_curve_fwd_f_parm p = new swap_curve_fwd_f_parm(parm);
	p.set_fixing_crv(fixing_crv);	
	return p;
}*/
//-------------------------------------------------------
// create 
//-------------------------------------------------------
/*swap_curve_fwd_f_parm swap_curve_fwd_f_parm(swap_curve_fwd_f_parm 	parm,
											curve option(nullable)	short_crv) 
							
{
	swap_curve_fwd_f_parm p = new swap_curve_fwd_f_parm(parm);
	p.set_short_crv(short_crv);
	return p;
}*/