
/*
	Basic swap wrapper classes and functions for "dual" bootstrap
	Developed by Algorithmica Research, Magnus Nyström
	
	
	Comments:
	
	
*/
option(null: hard);	

 
//-------------------------------------------------------
// fwd_b2_curve_create_synt (base case with basis swaps quoted as 2 swaps) (create synthetic fra(s) for fwd curve via basis spreads)
// Example 
//	1) fra_out_c = EUR 3M FRA, USD 6M FRA							[EUR3MFRA], [USD6MFRA]
//	2) swap_in_c = EUR IRS 6M EURIBOR, USD IRS 3M LIBOR				[EUR6MSWAP], [USD3MSWAP]
// 	3) basis_t1t2_c = EUR 3M/6M EURIBOR, USD 3M/6M LIBOR 		  	[EUR3M6MSWAP[2SWP]], [USD3M6MSWAP[2SWP]] 
//-------------------------------------------------------

swap_curve_b2_ext fwd_b2_curve_create_synt(	date 					d,
										disc_func					df_disc,
										fwd_func_tenor fwd_tenor,
										swap_curve_b2_f_parm		fwd_b2_parm,//contains fixing_crv, fra_out_crv, swap_in, basis
										disc_func option(nullable)	df_synt_base,
										date 						synt_end,
										logical 					x_pol_basis,										
										fwd_func option(nullable) 	fwd_pre , 
										date option(nullable)		fwd_pre_cut_off )
option (category: 'Yield Curve/003 Curve Building')
{	
				
	/*ir_index 	fwd_idx = null<ir_index>;
	integer 	freq_out = fwd_func_tenor.to_freq(fwd_tenor);

	if(fwd_b2_parm.short_is_fix_crv()) {
		string	fwd_tenor_s = string(fwd_tenor);
		fixing_curve new_f_crv;
		logical upd = CORE_INT.fwd_init(d,fwd_b2_parm.fixing_crv(), fwd_tenor,fwd_tenor_s,fwd_idx,new_f_crv);//after fwd_init the fixing curve will contain only 1 fixing instrument (for fwd_tenor)
		if(upd){
			//fwd_b2_parm =  swap_curve_b2_f_parm(fwd_b2_parm,new_f_crv);
			fwd_b2_parm.set_fixing_crv(new_f_crv);
		}
	}
	else {
		fwd_idx = null<ir_index>;
		curve new_short_crv;
		logical upd = CORE_INT.fwd_init_depo(fwd_b2_parm.short_crv(), fwd_tenor,new_short_crv);//after fwd_init the fixing curve will contain only 1 fixing instrument (for fwd_tenor)
		if(upd) {
			//fwd_b2_parm =  swap_curve_b2_f_parm(fwd_b2_parm,new_short_crv);
			fwd_b2_parm.set_short_crv(new_short_crv);
		}
	}

	if(null(fwd_idx)){
		if(check_curve(fwd_b2_parm.fra_crv())) {
			fwd_idx = fwd_b2_parm.fra_crv().instruments()[0].ir_index();
		}
		else if(check_curve(fwd_b2_parm.swap_crv())) {			
			fwd_idx = fwd_b2_parm.basis_crv().instruments()[0].swap_ir_index_leg1();
			fwd_func_tenor t = fwd_func_tenor.to_fwd_func_tenor(fwd_idx.tenor_code());
			if(fwd_tenor != t)
				fwd_idx = fwd_b2_parm.basis_crv().instruments()[0].swap_ir_index_leg2();
		}
	}
	*/
	//check swap curve and freq of first swap in curve
	/*vector(instrument) sw_in= fwd_b2_parm.swap_crv().instruments();
	QL_REQUIRE(v_size(sw_in) > 0, "invalid swap curve (in)");
	integer freq_sw_crv 	= sw_in[0].swap_reset_freq_leg2();
	QL_REQUIRE(freq_sw_crv > 0 && freq_sw_crv != 365, "invalid float reset frequency in swap curve", sw_in[0].name(), true);
	QL_REQUIRE(freq_out != freq_sw_crv , "invalid float reset frequency in swap curve (cannot be equal to fwd_tenor)", sw_in[0].name(), true);
	
	//check basis curve and swap class name tags
	integer freq_sw_base, freq_sw_flat;
	CORE_INT.check_b2_inst_freq(fwd_b2_parm.basis_crv(), freq_sw_base, freq_sw_flat);
	QL_REQUIRE(freq_out == freq_sw_base || freq_out == freq_sw_flat, "invalid fwd_tenor (not compatible with basis swap curve)");
	QL_REQUIRE(freq_sw_crv == freq_sw_base || freq_sw_crv == freq_sw_flat, "invalid float reset frequency in swap curve (not compatible with basis swap curve)");
	*/
	//check fra/fut/sps curve
	/*if(check_curve(fwd_b2_parm.fra_crv())) {
		instrument ii = fwd_b2_parm.fra_crv().instruments()[0];		
		integer _freq = -1;
		if(ii.is_fra() || ii.is_ir_future())
			_freq = ii.coupon_freq();
		else if(ii.is_swap_fixflt())
			_freq = ii.swap_coupon_freq_leg2();
		
		QL_REQUIRE(freq_out == _freq,"invalid fra/fut/sps curve (not compatible with fwd tenor)");
		if(null(fwd_idx))
			fwd_idx = fwd_b2_parm.fra_crv().instruments()[0].ir_index();
	}*/
	//FIX_ME  possibly need to create fwd_idx from swap
	/*QL_REQUIRE(!null(fwd_idx), "failed to create ir_index");
		

	swap_curve_b2_f_parm b2_parm_tmp;
	if(null(fwd_b2_parm.fixing_crv()))
		b2_parm_tmp = swap_curve_b2_f_parm(fwd_b2_parm.short_crv(), null<curve>, fwd_b2_parm.swap_crv(),
											fwd_b2_parm.basis_crv(),  fwd_b2_parm.blend_parm());
	else
		b2_parm_tmp = swap_curve_b2_f_parm(fwd_b2_parm.fixing_crv(), null<curve>, fwd_b2_parm.swap_crv(),
											fwd_b2_parm.basis_crv(),  fwd_b2_parm.blend_parm());

	swap_curve_ext s_tmp = swap_curve_b2_ext(fwd_tenor, b2_parm_tmp, d,df_disc, false, "");
	curve swap_out_crv = s_tmp.swap_curve();
					
	curve	df_basis_crv;		
	disc_func_spr df_basis = CORE_INT.df_tenor_spread(	d,null(df_synt_base) ? df_disc : df_synt_base, synt_end, fwd_b2_parm.short_crv(), 
														fwd_b2_parm.fra_crv(), swap_out_crv,fwd_b2_parm.prio1(),fwd_b2_parm.prio2(),
														fwd_b2_parm.merge_fra(),fwd_b2_parm.blend_buf_days(), df_basis_crv);
	QL_REQUIRE(!null(df_basis), "failed to create basis spread function");

	curve synt_crv;
	CORE_INT.synt_curve_create(d,fwd_b2_parm.fra_crv(), fwd_idx, df_basis, df_basis_crv,synt_crv);

	fwd_b2_parm.extend_fra_crv(synt_crv);
	
	*/
	string fwd_tenor_s = string(fwd_tenor);
	string name = strcat(["fwd_basis2_",fwd_tenor_s]);
	return swap_curve_b2_ext(fwd_tenor, fwd_b2_parm, d, df_disc,df_synt_base,synt_end, x_pol_basis, name,fwd_pre,fwd_pre_cut_off);	
				
}

//-------------------------------------------------------
// fwd_b2_curve_create (base case with basis swaps quoted as 2 swaps)
// Example 
//	1) fra_out_c = EUR 3M FRA, USD 6M FRA							[EUR3MFRA], [USD6MFRA]
//	2) swap_in_c = EUR IRS 6M EURIBOR, USD IRS 3M LIBOR				[EUR6MSWAP], [USD3MSWAP]
// 	3) basis_t1t2_c = EUR 3M/6M EURIBOR, USD 3M/6M LIBOR 		  	[EUR3M6MSWAP[2SWP]], [USD3M6MSWAP[2SWP]] 
//-------------------------------------------------------

swap_curve_b2_ext fwd_b2_curve_create(	date 						d,
										disc_func					df_disc,
										fwd_func_tenor fwd_tenor,
										swap_curve_b2_f_parm		fwd_b2_parm,//contains fixing_crv, fra_out_crv, swap_in, basis
										logical 					x_pol_basis,										
										fwd_func option(nullable) 	fwd_pre , 
										date option(nullable)		fwd_pre_cut_off )
option (category: 'Yield Curve/003 Curve Building')
{	
	//integer freq_out 		= fwd_func_tenor.to_freq(fwd_tenor);
	//string	fwd_tenor_s = string(fwd_tenor);			
	//ir_index 	fwd_idx = null<ir_index>;

	//kolla om raderna nedanför behövs på denna nivån, görs väl i swap_curve_b2_ext konstruktorn
	/*if(fwd_b2_parm.short_is_fix_crv_) {
		fixing_curve new_f_crv;
		logical upd = CORE_INT.fwd_init(d,fwd_b2_parm.fixing_crv(), fwd_tenor,fwd_tenor_s,fwd_idx,new_f_crv);//after fwd_init the fixing curve will contain only 1 fixing instrument (for fwd_tenor)
		if(upd)
			fwd_b2_parm =  swap_curve_b2_f_parm(fwd_b2_parm,new_f_crv);
	}
	else {
		fwd_idx = null<ir_index>;
		curve new_short_crv;
		logical upd = CORE_INT.fwd_init_depo(d,fwd_b2_parm.short_crv_, fwd_tenor,fwd_tenor_s,new_short_crv);//after fwd_init the fixing curve will contain only 1 fixing instrument (for fwd_tenor)
		if(upd)
			fwd_b2_parm =  swap_curve_b2_f_parm(fwd_b2_parm,new_short_crv);
	}*/
	
	//check swap curve and freq of first swap in curve
	/*vector(instrument) sw_in= fwd_b2_parm.swap_crv().instruments();
	QL_REQUIRE(v_size(sw_in) > 0, "invalid swap curve (in)");
	integer freq_sw_crv 	= sw_in[0].swap_coupon_freq_leg2();
	QL_REQUIRE(freq_sw_crv > 0 && freq_sw_crv != 365, "invalid float coupon frequency in swap curve", sw_in[0].name(), true);
	QL_REQUIRE(freq_out != freq_sw_crv , "invalid float coupon frequency in swap curve (cannot be equal to fwd_tenor)", sw_in[0].name(), true);
	*/
	//check basis curve and swap class name tags
	/*integer freq_sw_base, freq_sw_flat;
	CORE_INT.check_b2_inst_freq(fwd_b2_parm.basis_crv(), freq_sw_base, freq_sw_flat);
	QL_REQUIRE(freq_out == freq_sw_base || freq_out == freq_sw_flat, "invalid fwd_tenor (not compatible with basis swap curve)");
	QL_REQUIRE(freq_sw_crv == freq_sw_base || freq_sw_crv == freq_sw_flat, "invalid float coupon frequency in swap curve (not compatible with basis swap curve)");
	*/
	//check fra curve
	/*if(check_curve(fwd_b2_parm.fra_crv())) {
		instrument ii = fwd_b2_parm.fra_crv().instruments()[0];		
		integer _freq = -1;
		if(ii.is_fra() || ii.is_ir_future())
			_freq = ii.coupon_freq();
		else if(ii.is_swap_fixflt())
			_freq = ii.swap_coupon_freq_leg2();
		QL_REQUIRE(freq_out == _freq,"invalid fra/fut/sps curve (not compatible with fwd tenor)");
	}*/
	//string name = strcat(["fwd_basis2_",str(12/freq_out,0),"M"]);

	string fwd_tenor_s = string(fwd_tenor);
	string name = strcat(["fwd_basis2_",fwd_tenor_s]);
	return swap_curve_b2_ext(fwd_tenor, fwd_b2_parm, d, df_disc, x_pol_basis, name,fwd_pre,fwd_pre_cut_off);	
				
}

//-------------------------------------------------------
// fwd_b2_curve_create_f_synt (base case with basis swaps quoted as 2 swaps)
//-------------------------------------------------------

fwd_func fwd_b2_curve_create_f_synt(date 						d,
									disc_func					df_disc,
									fwd_func_tenor fwd_tenor,
									swap_curve_b2_f_parm		fwd_b2_parm,//contains fixing_crv, fra_out_crv, swap_in, basis
									disc_func option(nullable)	df_synt_base,
									date 						synt_end,
									fwd_z_model  				fwd_model,							
									logical 					x_pol_basis,
									out swap_curve_b2_ext 		fwd_crv,													
									fwd_func option(nullable) 	fwd_pre , 
									date option(nullable)		fwd_pre_cut_off)
option (category: 'Yield Curve/003 Curve Building')
{			
	fwd_crv = fwd_b2_curve_create_synt(d,df_disc,fwd_tenor, fwd_b2_parm, df_synt_base,synt_end, x_pol_basis, fwd_pre,fwd_pre_cut_off);
	return fwd_crv.fwd(fwd_model);							
}

//-------------------------------------------------------
// fwd_b2_curve_create_f (base case with basis swaps quoted as 2 swaps)
//-------------------------------------------------------

fwd_func fwd_b2_curve_create_f(	date 						d,
								disc_func					df_disc,
								fwd_func_tenor fwd_tenor,
								swap_curve_b2_f_parm		fwd_b2_parm,//contains fixing_crv, fra_out_crv, swap_in, basis							
								fwd_z_model  				fwd_model,							
								logical 					x_pol_basis,
								out swap_curve_b2_ext 		fwd_crv,													
								fwd_func option(nullable) 	fwd_pre , 
								date option(nullable)		fwd_pre_cut_off )
option (category: 'Yield Curve/003 Curve Building')
{			
	fwd_crv = fwd_b2_curve_create(d,df_disc,fwd_tenor, fwd_b2_parm, x_pol_basis, fwd_pre,fwd_pre_cut_off);
	return fwd_crv.fwd(fwd_model);							
}
//-------------------------------------------------------
// fwd_b2_curve_create_synt (base case with basis swaps quoted as 2 swaps)
//-------------------------------------------------------

fwd_func fwd_b2_curve_create_f_synt(date 						d,
									disc_func					df_disc,
									fwd_func_tenor fwd_tenor,
									swap_curve_b2_f_parm		fwd_b2_parm,//contains fixing_crv, fra_out_crv, swap_in, basis
									disc_func option(nullable)	df_synt_base,
									date 						synt_end,
									fwd_z_model  				fwd_model,							
									logical						model_spr,
									fwd_func option(nullable)	fwd_func_base,
									logical 					x_pol_basis,
									out swap_curve_b2_ext 		fwd_crv,													
									fwd_func option(nullable) 	fwd_pre , 
									date option(nullable)		fwd_pre_cut_off)
option (category: 'Yield Curve/003 Curve Building')
{			
	fwd_crv = fwd_b2_curve_create_synt(d,df_disc,fwd_tenor, fwd_b2_parm, df_synt_base,synt_end, x_pol_basis, fwd_pre,fwd_pre_cut_off);
	if(model_spr){
		QL_REQUIRE(!null(fwd_func_base), "invalid fwd_func_base (required when modelling the spread)");
		return fwd_crv.fwd_spr(fwd_func_base,fwd_model);
	}
	else
		return fwd_crv.fwd(fwd_model);							
}



//-------------------------------------------------------
// fwd_b2_curve_create (base case with basis swaps quoted as 2 swaps)
//-------------------------------------------------------

fwd_func fwd_b2_curve_create_f(	date 						d,
								disc_func					df_disc,
								fwd_func_tenor fwd_tenor,
								swap_curve_b2_f_parm		fwd_b2_parm,//contains fixing_crv, fra_out_crv, swap_in, basis							
								fwd_z_model  				fwd_model,							
								logical						model_spr,
								fwd_func option(nullable)	fwd_func_base,
								logical 					x_pol_basis,
								out swap_curve_b2_ext 		fwd_crv,													
								fwd_func option(nullable) 	fwd_pre , 
								date option(nullable)		fwd_pre_cut_off)
option (category: 'Yield Curve/003 Curve Building')
{			
	fwd_crv = fwd_b2_curve_create(d,df_disc,fwd_tenor, fwd_b2_parm, x_pol_basis, fwd_pre,fwd_pre_cut_off);
	if(model_spr){
		QL_REQUIRE(!null(fwd_func_base), "invalid fwd_func_base (required when modelling the spread)");
		return fwd_crv.fwd_spr(fwd_func_base,fwd_model);
	}
	else
		return fwd_crv.fwd(fwd_model);							
}

//-------------------------------------------------------
// fwd_b2_curve_create_tmpl
//-------------------------------------------------------
swap_curve_b2_ext fwd_b2_curve_create_tmpl(	date 							d,											
											fwd_func_tenor	fwd_tenor,
											CURVE_TMPL.fwd_curve_model_tmpl model,											
											curve option(nullable)			short_crv,
											logical	option(nullable)		short_crv_is_fix,
											curve option(nullable)			fra_crv,
											curve 							swap_crv,
											curve 							basis_crv,
											disc_func						df,
											disc_func option(nullable)		df_synt_base,
											date option(nullable)			synt_end,											
											out fwd_z_model 				fwd_model,
											fwd_func option(nullable) 		fwd_pre , 
											date option(nullable)			fwd_pre_cut_off,
											vector(number) option(nullable) edfut_cvx_adj )
	option (category: 'Yield Curve/003 Curve Building')
{
	/*fwd_model_parm fwd_p = fwd_model_parm();
	
	if(!null(model.z_model_e()))
		fwd_p.set_model(model.z_model_e());
	
	fwd_model = init_fwd_model(fwd_p);*/
	
	fwd_model = model.fwd_model();
	
	vector(number) fra_crv_y_spr, basis_crv_q_spr,swap_crv_y_spr;
	swap_curve_b2_f_parm fwd_parm;

	QL_FAIL_COND(!null(short_crv) && null(short_crv_is_fix),"invalid fixing flag for short curve");
	if(null(short_crv_is_fix))
		short_crv_is_fix = false;
	
	if(short_crv_is_fix)
		fwd_parm = swap_curve_b2_f_parm(fixing_curve(short_crv),fra_crv,swap_crv,basis_crv, model.blend_parm(),
										fra_crv_y_spr,swap_crv_y_spr, basis_crv_q_spr,edfut_cvx_adj);
	else
		fwd_parm = swap_curve_b2_f_parm(short_crv, fra_crv, swap_crv,basis_crv,  model.blend_parm(),
										fra_crv_y_spr, swap_crv_y_spr,basis_crv_q_spr,edfut_cvx_adj);
	
	swap_curve_b2_ext fwd_crv;
	if(model.incl_synt())			
		fwd_crv	= fwd_b2_curve_create_synt(	d,df,fwd_tenor,
											fwd_parm,
											df_synt_base,
											synt_end,
											model.x_pol_basis(),
											fwd_pre , 
											fwd_pre_cut_off );
	else
		fwd_crv	= fwd_b2_curve_create(d,df,
										fwd_tenor,	
										fwd_parm,		
										model.x_pol_basis(),
										fwd_pre , 
										fwd_pre_cut_off);
	return fwd_crv;
}

//-------------------------------------------------------
// fwd_b2_curve_create_tmpl
//-------------------------------------------------------
swap_curve_b2_ext fwd_b2_curve_create_tmpl(	date 								d,
											CURVE_TMPL.fwd_basis_2swp_curve_tmpl 	fwd_c,
											CURVE_TMPL.fwd_curve_model_tmpl 	model,
											disc_func							df,
											disc_func option(nullable)			df_synt_base,
											date option(nullable)				synt_end,
											out fwd_z_model 					fwd_model,
											fwd_func option(nullable) 			fwd_pre , 
											date option(nullable)				fwd_pre_cut_off,
											vector(number) option(nullable) 	edfut_cvx_adj = null<vector(number)> )
	option (category: 'Yield Curve/003 Curve Building')
{
	error_info err = new error_info(true,true);
	return fwd_b2_curve_create_tmpl(d,fwd_c.fwd_tenor(),
									model,
									fwd_c.short_crv(d, null<quote_side>,err),
									fwd_c.short_crv_is_fix(),
									fwd_c.middle_crv(d, null<quote_side>,err),
									fwd_c.long_base_crv(d, null<quote_side>,err),
									fwd_c.basis_crv(d, null<quote_side>,err),
									df,df_synt_base,synt_end,fwd_model,
									fwd_pre,fwd_pre_cut_off,edfut_cvx_adj);
}


//-------------------------------------------------------
// fwd_b2_curve_create_tmpl
//-------------------------------------------------------
fwd_func fwd_b2_curve_create_f_tmpl(date 							d,											
									fwd_func_tenor	fwd_tenor,
									CURVE_TMPL.fwd_curve_model_tmpl model,											
									curve option(nullable)			short_crv,
									logical	option(nullable)		short_crv_is_fix,
									curve option(nullable)			middle_crv,
									curve 							long_crv,
									curve 							basis_crv,
									disc_func						df,
									disc_func option(nullable)		df_synt_base,
									date option(nullable)			synt_end,
									fwd_func option(nullable) 		fwd_func_base,
									out swap_curve_b2_ext 			fwd_crv,								
									fwd_func option(nullable) 		fwd_pre , 
									date option(nullable)			fwd_pre_cut_off,
									vector(number) option(nullable) edfut_cvx_adj  )
	option (category: 'Yield Curve/003 Curve Building')
{
	fwd_z_model fwd_model;
	fwd_crv = fwd_b2_curve_create_tmpl(d,fwd_tenor,
									model,
									short_crv,short_crv_is_fix,
									middle_crv,
									long_crv,
									basis_crv,
									df,df_synt_base,synt_end,fwd_model,
									fwd_pre,fwd_pre_cut_off,edfut_cvx_adj);
	
	if(model.model_spr()){
		QL_REQUIRE(!null(fwd_func_base), "invalid fwd_func_base (required when modelling the spread)");
		return fwd_crv.fwd_spr(fwd_func_base,fwd_model);
	}
	else
		return fwd_crv.fwd(fwd_model);
}

//-------------------------------------------------------
// fwd_b2_curve_create_tmpl
//-------------------------------------------------------
fwd_func fwd_b2_curve_create_f_tmpl(date 								d,
									CURVE_TMPL.fwd_basis_2swp_curve_tmpl 	fwd_c,
									CURVE_TMPL.fwd_curve_model_tmpl 	model,
									disc_func							df,
									disc_func option(nullable)			df_synt_base,
									date option(nullable)				synt_end,
									fwd_func option(nullable) 			fwd_func_base,
									out swap_curve_b2_ext 				fwd_crv,									
									fwd_func option(nullable) 			fwd_pre , 
									date option(nullable)				fwd_pre_cut_off,
									vector(number) option(nullable) 	edfut_cvx_adj = null<vector(number)>)
	option (category: 'Yield Curve/003 Curve Building')
{
	error_info err = new error_info(true,true);
	fwd_z_model fwd_model;
	fwd_crv = fwd_b2_curve_create_tmpl(	d,
										fwd_c.fwd_tenor(),
										model,
										fwd_c.short_crv(d, null<quote_side>,err),
										fwd_c.short_crv_is_fix(),
										fwd_c.middle_crv(d, null<quote_side>,err),
										fwd_c.long_base_crv(d, null<quote_side>,err),
										fwd_c.basis_crv(d, null<quote_side>,err),
										df,df_synt_base,synt_end,fwd_model,
										fwd_pre,fwd_pre_cut_off,edfut_cvx_adj);

	
	if(model.model_spr()){
		QL_REQUIRE(!null(fwd_func_base), "invalid fwd_func_base (required when modelling the spread)");
		return fwd_crv.fwd_spr(fwd_func_base,fwd_model);
	}
	else
		return fwd_crv.fwd(fwd_model);
}
